'\"
'\" Generated from file '/home/aku/Projects/KineTcl/dev/embedded/man/files/kinetcl.n' by tcllib/doctools with format 'nroff'
'\" Copyright (c) 2012 Andreas Kupries
'\" Copyright (c) 2012 Documentation, Andreas Kupries
'\"
'\" The definitions below are for supplemental macros used in Tcl/Tk
'\" manual entries.
'\"
'\" .AP type name in/out ?indent?
'\"	Start paragraph describing an argument to a library procedure.
'\"	type is type of argument (int, etc.), in/out is either "in", "out",
'\"	or "in/out" to describe whether procedure reads or modifies arg,
'\"	and indent is equivalent to second arg of .IP (shouldn't ever be
'\"	needed;  use .AS below instead)
'\"
'\" .AS ?type? ?name?
'\"	Give maximum sizes of arguments for setting tab stops.  Type and
'\"	name are examples of largest possible arguments that will be passed
'\"	to .AP later.  If args are omitted, default tab stops are used.
'\"
'\" .BS
'\"	Start box enclosure.  From here until next .BE, everything will be
'\"	enclosed in one large box.
'\"
'\" .BE
'\"	End of box enclosure.
'\"
'\" .CS
'\"	Begin code excerpt.
'\"
'\" .CE
'\"	End code excerpt.
'\"
'\" .VS ?version? ?br?
'\"	Begin vertical sidebar, for use in marking newly-changed parts
'\"	of man pages.  The first argument is ignored and used for recording
'\"	the version when the .VS was added, so that the sidebars can be
'\"	found and removed when they reach a certain age.  If another argument
'\"	is present, then a line break is forced before starting the sidebar.
'\"
'\" .VE
'\"	End of vertical sidebar.
'\"
'\" .DS
'\"	Begin an indented unfilled display.
'\"
'\" .DE
'\"	End of indented unfilled display.
'\"
'\" .SO
'\"	Start of list of standard options for a Tk widget.  The
'\"	options follow on successive lines, in four columns separated
'\"	by tabs.
'\"
'\" .SE
'\"	End of list of standard options for a Tk widget.
'\"
'\" .OP cmdName dbName dbClass
'\"	Start of description of a specific option.  cmdName gives the
'\"	option's name as specified in the class command, dbName gives
'\"	the option's name in the option database, and dbClass gives
'\"	the option's class in the option database.
'\"
'\" .UL arg1 arg2
'\"	Print arg1 underlined, then print arg2 normally.
'\"
'\" RCS: @(#) $Id: man.macros,v 1.1 2009/01/30 04:56:47 andreas_kupries Exp $
'\"
'\"	# Set up traps and other miscellaneous stuff for Tcl/Tk man pages.
.if t .wh -1.3i ^B
.nr ^l \n(.l
.ad b
'\"	# Start an argument description
.de AP
.ie !"\\$4"" .TP \\$4
.el \{\
.   ie !"\\$2"" .TP \\n()Cu
.   el          .TP 15
.\}
.ta \\n()Au \\n()Bu
.ie !"\\$3"" \{\
\&\\$1	\\fI\\$2\\fP	(\\$3)
.\".b
.\}
.el \{\
.br
.ie !"\\$2"" \{\
\&\\$1	\\fI\\$2\\fP
.\}
.el \{\
\&\\fI\\$1\\fP
.\}
.\}
..
'\"	# define tabbing values for .AP
.de AS
.nr )A 10n
.if !"\\$1"" .nr )A \\w'\\$1'u+3n
.nr )B \\n()Au+15n
.\"
.if !"\\$2"" .nr )B \\w'\\$2'u+\\n()Au+3n
.nr )C \\n()Bu+\\w'(in/out)'u+2n
..
.AS Tcl_Interp Tcl_CreateInterp in/out
'\"	# BS - start boxed text
'\"	# ^y = starting y location
'\"	# ^b = 1
.de BS
.br
.mk ^y
.nr ^b 1u
.if n .nf
.if n .ti 0
.if n \l'\\n(.lu\(ul'
.if n .fi
..
'\"	# BE - end boxed text (draw box now)
.de BE
.nf
.ti 0
.mk ^t
.ie n \l'\\n(^lu\(ul'
.el \{\
.\"	Draw four-sided box normally, but don't draw top of
.\"	box if the box started on an earlier page.
.ie !\\n(^b-1 \{\
\h'-1.5n'\L'|\\n(^yu-1v'\l'\\n(^lu+3n\(ul'\L'\\n(^tu+1v-\\n(^yu'\l'|0u-1.5n\(ul'
.\}
.el \}\
\h'-1.5n'\L'|\\n(^yu-1v'\h'\\n(^lu+3n'\L'\\n(^tu+1v-\\n(^yu'\l'|0u-1.5n\(ul'
.\}
.\}
.fi
.br
.nr ^b 0
..
'\"	# VS - start vertical sidebar
'\"	# ^Y = starting y location
'\"	# ^v = 1 (for troff;  for nroff this doesn't matter)
.de VS
.if !"\\$2"" .br
.mk ^Y
.ie n 'mc \s12\(br\s0
.el .nr ^v 1u
..
'\"	# VE - end of vertical sidebar
.de VE
.ie n 'mc
.el \{\
.ev 2
.nf
.ti 0
.mk ^t
\h'|\\n(^lu+3n'\L'|\\n(^Yu-1v\(bv'\v'\\n(^tu+1v-\\n(^Yu'\h'-|\\n(^lu+3n'
.sp -1
.fi
.ev
.\}
.nr ^v 0
..
'\"	# Special macro to handle page bottom:  finish off current
'\"	# box/sidebar if in box/sidebar mode, then invoked standard
'\"	# page bottom macro.
.de ^B
.ev 2
'ti 0
'nf
.mk ^t
.if \\n(^b \{\
.\"	Draw three-sided box if this is the box's first page,
.\"	draw two sides but no top otherwise.
.ie !\\n(^b-1 \h'-1.5n'\L'|\\n(^yu-1v'\l'\\n(^lu+3n\(ul'\L'\\n(^tu+1v-\\n(^yu'\h'|0u'\c
.el \h'-1.5n'\L'|\\n(^yu-1v'\h'\\n(^lu+3n'\L'\\n(^tu+1v-\\n(^yu'\h'|0u'\c
.\}
.if \\n(^v \{\
.nr ^x \\n(^tu+1v-\\n(^Yu
\kx\h'-\\nxu'\h'|\\n(^lu+3n'\ky\L'-\\n(^xu'\v'\\n(^xu'\h'|0u'\c
.\}
.bp
'fi
.ev
.if \\n(^b \{\
.mk ^y
.nr ^b 2
.\}
.if \\n(^v \{\
.mk ^Y
.\}
..
'\"	# DS - begin display
.de DS
.RS
.nf
.sp
..
'\"	# DE - end display
.de DE
.fi
.RE
.sp
..
'\"	# SO - start of list of standard options
.de SO
.SH "STANDARD OPTIONS"
.LP
.nf
.ta 4c 8c 12c
.ft B
..
'\"	# SE - end of list of standard options
.de SE
.fi
.ft R
.LP
See the \\fBoptions\\fR manual entry for details on the standard options.
..
'\"	# OP - start of full description for a single option
.de OP
.LP
.nf
.ta 4c
Command-Line Name:	\\fB\\$1\\fR
Database Name:	\\fB\\$2\\fR
Database Class:	\\fB\\$3\\fR
.fi
.IP
..
'\"	# CS - begin code excerpt
.de CS
.RS
.nf
.ta .25i .5i .75i 1i
..
'\"	# CE - end code excerpt
.de CE
.fi
.RE
..
.de UL
\\$1\l'|0\(ul'\\$2
..
.TH "kinetcl" n 0.1 doc "KineTcl"
.BS
.SH NAME
kinetcl \- KineTcl - API
.SH SYNOPSIS
package require \fBTcl  8.5\fR
.sp
package require \fBkinetcl  ?0.1?\fR
.sp
\fB::kinetcl estart\fR
.sp
\fB::kinetcl estop\fR
.sp
\fB::kinetcl start\fR
.sp
\fB::kinetcl stop\fR
.sp
\fB::kinetcl waitUpdate\fR
.sp
\fB::kinetcl waitAnyUpdate\fR
.sp
\fB::kinetcl waitNoneUpdate\fR
.sp
\fB::kinetcl waitOneUpdate\fR \fInode\fR
.sp
\fB::kinetcl errorstate\fR
.sp
\fB::kinetcl mirror\fR ?\fIbool\fR?
.sp
\fB::kinetcl base\fR \fBnew\fR
.sp
\fB::kinetcl base\fR \fBcreate\fR \fIobjname\fR
.sp
\fIbaseInstanceCmd\fR \fBcapabilities\fR ?\fB-all\fR?
.sp
\fIbaseInstanceCmd\fR \fBis-capable-of\fR \fIcapability\fR
.sp
\fIbaseInstanceCmd\fR \fBnode-info\fR
.sp
\fIbaseInstanceCmd\fR \fBnode-name\fR
.sp
\fIbaseInstanceCmd\fR \fBbind\fR \fIevent\fR \fIcommand\fR
.sp
\fB{*}command\fR \fIevent\fR \fIobj\fR \fIdetails\fR
.sp
\fIbaseInstanceCmd\fR \fBunbind\fR \fItoken\fR
.sp
\fB::kinetcl generator\fR \fBnew\fR
.sp
\fB::kinetcl generator\fR \fBcreate\fR \fIobjname\fR
.sp
\fIgeneratorInstanceCmd\fR \fBstart\fR
.sp
\fIgeneratorInstanceCmd\fR \fBstop\fR
.sp
\fIgeneratorInstanceCmd\fR \fBactive\fR
.sp
\fIgeneratorInstanceCmd\fR \fBupdate\fR
.sp
\fIgeneratorInstanceCmd\fR \fBhasNew\fR
.sp
\fIgeneratorInstanceCmd\fR \fBisNew\fR
.sp
\fIgeneratorInstanceCmd\fR \fBframe\fR
.sp
\fIgeneratorInstanceCmd\fR \fBtime\fR
.sp
\fB::kinetcl map\fR \fBnew\fR
.sp
\fB::kinetcl map\fR \fBcreate\fR \fIobjname\fR
.sp
\fImapInstanceCmd\fR \fBbytes-per-pixel\fR
.sp
\fImapInstanceCmd\fR \fBmodes\fR
.sp
\fImapInstanceCmd\fR \fBmode\fR
.sp
\fImapInstanceCmd\fR \fBmode\fR \fIxres\fR \fIyres\fR \fIfps\fR
.sp
\fB::kinetcl depth\fR \fBnew\fR
.sp
\fB::kinetcl depth\fR \fBcreate\fR \fIobjname\fR
.sp
\fIdepthInstanceCmd\fR \fBdestroy\fR
.sp
\fIdepthInstanceCmd\fR \fBmax-depth\fR
.sp
\fIdepthInstanceCmd\fR \fBfov\fR
.sp
\fIdepthInstanceCmd\fR \fBmeta\fR
.sp
\fIdepthInstanceCmd\fR \fBmap\fR
.sp
\fIdepthInstanceCmd\fR \fBprojective2world\fR \fIpoint\fR...
.sp
\fIdepthInstanceCmd\fR \fBworld2projective\fR \fIpoint\fR...
.sp
\fB::kinetcl image\fR \fBnew\fR
.sp
\fB::kinetcl image\fR \fBcreate\fR \fIobjname\fR
.sp
\fIimageInstanceCmd\fR \fBdestroy\fR
.sp
\fIimageInstanceCmd\fR \fBformats\fR
.sp
\fIimageInstanceCmd\fR \fBformat\fR ?\fIformat\fR?
.sp
\fIimageInstanceCmd\fR \fBmeta\fR
.sp
\fIimageInstanceCmd\fR \fBmap\fR
.sp
\fB::kinetcl ir\fR \fBnew\fR
.sp
\fB::kinetcl ir\fR \fBcreate\fR \fIobjname\fR
.sp
\fIirIstanceCmd\fR \fBdestroy\fR
.sp
\fB::kinetcl gesture\fR \fBnew\fR
.sp
\fB::kinetcl gesture\fR \fBcreate\fR \fIobjname\fR
.sp
\fIgestureInstanceCmd\fR \fBdestroy\fR
.sp
\fIgestureInstanceCmd\fR \fBadd-gesture\fR \fIgesture\fR ?\fIbox\fR?
.sp
\fIgestureInstanceCmd\fR \fBremove-gesture\fR \fIgesture\fR
.sp
\fIgestureInstanceCmd\fR \fBis-gesture\fR \fIgesture\fR
.sp
\fIgestureInstanceCmd\fR \fBgesture-has-progress\fR \fIgesture\fR
.sp
\fIgestureInstanceCmd\fR \fBall-gestures\fR
.sp
\fIgestureInstanceCmd\fR \fBactive-gestures\fR
.sp
\fB::kinetcl scene\fR
.sp
\fIsceneInstanceCmd\fR \fBdestroy\fR
.sp
\fIsceneInstanceCmd\fR \fBmeta\fR
.sp
\fIsceneInstanceCmd\fR \fBmap\fR
.sp
\fIsceneInstanceCmd\fR \fBfloor\fR
.sp
\fB::kinetcl user\fR \fBnew\fR
.sp
\fB::kinetcl user\fR \fBcreate\fR \fIobjname\fR
.sp
\fIuserInstanceCmd\fR \fBdestroy\fR
.sp
\fIuserInstanceCmd\fR \fBcount\fR
.sp
\fIuserInstanceCmd\fR \fBusers\fR
.sp
\fIuserInstanceCmd\fR \fBcenterof\fR \fIid\fR
.sp
\fIuserInstanceCmd\fR \fBpixelsof\fR \fIid\fR
.sp
\fB::kinetcl hands\fR \fBnew\fR
.sp
\fB::kinetcl hands\fR \fBcreate\fR \fIobjname\fR
.sp
\fIhandsInstanceCmd\fR \fBdestroy\fR
.sp
\fIinstanceCmd\fR \fBset-smoothing\fR \fIfactor\fR
.sp
\fIinstanceCmd\fR \fBstart-tracking\fR \fIpoint\fR
.sp
\fIinstanceCmd\fR \fBstop-tracking\fR \fIid\fR
.sp
\fIinstanceCmd\fR \fBstop-tracking-all\fR
.sp
\fB::kinetcl audio\fR \fBnew\fR
.sp
\fB::kinetcl audio\fR \fBcreate\fR \fIobjname\fR
.sp
\fIaudioInstanceCmd\fR \fBdestroy\fR
.sp
\fB::kinetcl recorder\fR \fBnew\fR
.sp
\fB::kinetcl recorder\fR \fBcreate\fR \fIobjname\fR
.sp
\fIrecorderInstanceCmd\fR \fBdestroy\fR
.sp
\fB::kinetcl player\fR \fBnew\fR
.sp
\fB::kinetcl player\fR \fBcreate\fR \fIobjname\fR
.sp
\fIplayerInstanceCmd\fR \fBdestroy\fR
.sp
\fIplayerInstanceCmd\fR \fBspeed\fR \fIspeed\fR
.sp
\fIplayerInstanceCmd\fR \fBspeed\fR
.sp
\fIplayerInstanceCmd\fR \fBrepeat\fR \fIbool\fR
.sp
\fIplayerInstanceCmd\fR \fBeof\fR
.sp
\fIplayerInstanceCmd\fR \fBformat\fR
.sp
\fIplayerInstanceCmd\fR \fBnext\fR
.sp
\fB::kinetcl script\fR \fBnew\fR
.sp
\fB::kinetcl script\fR \fBcreate\fR \fIobjname\fR
.sp
\fIscriptInstanceCmd\fR \fBdestroy\fR
.sp
\fIinstanceCmd\fR \fBsupports-view\fR \fInode\fR
.sp
\fIinstanceCmd\fR \fBset-view\fR \fInode\fR
.sp
\fIinstanceCmd\fR \fBreset-view\fR
.sp
\fIinstanceCmd\fR \fBusing-view\fR \fInode\fR
.sp
\fIinstanceCmd\fR \fBfrequency\fR
.sp
\fIinstanceCmd\fR \fBcrop\fR \fIfrequency\fR
.sp
\fIinstanceCmd\fR \fBcrop\fR
.sp
\fIinstanceCmd\fR \fBcrop\fR \fIx\fR \fIy\fR \fIw\fR \fIh\fR
.sp
\fIinstanceCmd\fR \fBuncrop\fR
.sp
\fIinstanceCmd\fR \fBcan-sync-with\fR \fInode\fR
.sp
\fIinstanceCmd\fR \fBstart-sync-with\fR \fInode\fR
.sp
\fIinstanceCmd\fR \fBstop-sync-with\fR \fInode\fR
.sp
\fIinstanceCmd\fR \fBsynced-with\fR \fInode\fR
.sp
\fIinstanceCmd\fR \fBmirror\fR
.sp
\fIinstanceCmd\fR \fBmirror\fR \fIbool\fR
.sp
\fIinstanceCmd\fR \fBposes\fR
.sp
\fIinstanceCmd\fR \fBis-supported\fR \fIpose\fR
.sp
\fIinstanceCmd\fR \fBstart-detection\fR \fIuser\fR \fIpose\fR
.sp
\fIinstanceCmd\fR \fBstop-detection\fR \fIuser\fR \fIpose\fR
.sp
\fIinstanceCmd\fR \fBstop-all-detection\fR \fIuser\fR
.sp
\fIinstanceCmd\fR \fBstatus\fR \fIuser\fR \fIpose\fR
.sp
\fIinstanceCmd\fR \fBneed-pose\fR
.sp
\fIinstanceCmd\fR \fBis-profile-available\fR \fIprofile\fR
.sp
\fIinstanceCmd\fR \fBset-profile\fR \fIprofile\fR
.sp
\fIinstanceCmd\fR \fBset-smoothing\fR \fIfactor\fR
.sp
\fIinstanceCmd\fR \fBstart-tracking\fR \fIid\fR
.sp
\fIinstanceCmd\fR \fBstop-tracking\fR \fIid\fR
.sp
\fIinstanceCmd\fR \fBreset-tracking\fR \fIid\fR
.sp
\fIinstanceCmd\fR \fBis-tracking\fR \fIid\fR
.sp
\fIinstanceCmd\fR \fBis-calibrated\fR \fIid\fR
.sp
\fIinstanceCmd\fR \fBis-calibrating\fR \fIid\fR
.sp
\fIinstanceCmd\fR \fBrequest-calibration\fR \fIid\fR \fIforce\fR
.sp
\fIinstanceCmd\fR \fBabort-calibration\fR \fIid\fR
.sp
\fIinstanceCmd\fR \fBsave-calibration-file\fR \fIid\fR \fIpath\fR
.sp
\fIinstanceCmd\fR \fBload-calibration-file\fR \fIid\fR \fIpath\fR
.sp
\fIinstanceCmd\fR \fBsave-calibration\fR \fIid\fR \fIslot\fR
.sp
\fIinstanceCmd\fR \fBload-calibration-slot\fR \fIid\fR \fIslot\fR
.sp
\fIinstanceCmd\fR \fBclear-calibration-slot\fR \fIslot\fR
.sp
\fIinstanceCmd\fR \fBis-calibration-slot\fR \fIslot\fR
.sp
\fIinstanceCmd\fR \fBis-joint-available\fR \fIjoint\fR
.sp
\fIinstanceCmd\fR \fBis-joint-active\fR \fIjoint\fR
.sp
\fIinstanceCmd\fR \fBset-joint-active\fR \fIjoint\fR \fIactive\fR
.sp
\fIinstanceCmd\fR \fBactive-joints\fR
.sp
\fIinstanceCmd\fR \fBget-joint\fR \fIuser\fR \fIjoint\fR
.sp
\fIinstanceCmd\fR \fBget-skeleton\fR \fIuser\fR
.sp
\fIinstanceCmd\fR \fBbacklight-compensation\fR
.sp
\fIinstanceCmd\fR \fBbacklight-compensation\fR \fIvalue\fR
.sp
\fIinstanceCmd\fR \fBbacklight-compensation-range\fR
.sp
\fIinstanceCmd\fR \fBbrightness\fR
.sp
\fIinstanceCmd\fR \fBbrightness\fR \fIvalue\fR
.sp
\fIinstanceCmd\fR \fBbrightness-range\fR
.sp
\fIinstanceCmd\fR \fBcolor-temperature\fR
.sp
\fIinstanceCmd\fR \fBcolor-temperature\fR \fIvalue\fR
.sp
\fIinstanceCmd\fR \fBcolor-temperature-range\fR
.sp
\fIinstanceCmd\fR \fBcontrast\fR
.sp
\fIinstanceCmd\fR \fBcontrast\fR \fIvalue\fR
.sp
\fIinstanceCmd\fR \fBcontrast-range\fR
.sp
\fIinstanceCmd\fR \fBexposure\fR
.sp
\fIinstanceCmd\fR \fBexposure\fR \fIvalue\fR
.sp
\fIinstanceCmd\fR \fBexposure-range\fR
.sp
\fIinstanceCmd\fR \fBfocus\fR
.sp
\fIinstanceCmd\fR \fBfocus\fR \fIvalue\fR
.sp
\fIinstanceCmd\fR \fBfocus-range\fR
.sp
\fIinstanceCmd\fR \fBgain\fR
.sp
\fIinstanceCmd\fR \fBgain\fR \fIvalue\fR
.sp
\fIinstanceCmd\fR \fBgain-range\fR
.sp
\fIinstanceCmd\fR \fBgamma\fR
.sp
\fIinstanceCmd\fR \fBgamma\fR \fIvalue\fR
.sp
\fIinstanceCmd\fR \fBgamma-range\fR
.sp
\fIinstanceCmd\fR \fBhue\fR
.sp
\fIinstanceCmd\fR \fBhue\fR \fIvalue\fR
.sp
\fIinstanceCmd\fR \fBhue-range\fR
.sp
\fIinstanceCmd\fR \fBiris\fR
.sp
\fIinstanceCmd\fR \fBiris\fR \fIvalue\fR
.sp
\fIinstanceCmd\fR \fBiris-range\fR
.sp
\fIinstanceCmd\fR \fBlowlight-compensation\fR
.sp
\fIinstanceCmd\fR \fBlowlight-compensation\fR \fIvalue\fR
.sp
\fIinstanceCmd\fR \fBlowlight-compensation-range\fR
.sp
\fIinstanceCmd\fR \fBpan\fR
.sp
\fIinstanceCmd\fR \fBpan\fR \fIvalue\fR
.sp
\fIinstanceCmd\fR \fBpan-range\fR
.sp
\fIinstanceCmd\fR \fBroll\fR
.sp
\fIinstanceCmd\fR \fBroll\fR \fIvalue\fR
.sp
\fIinstanceCmd\fR \fBroll-range\fR
.sp
\fIinstanceCmd\fR \fBsaturation\fR
.sp
\fIinstanceCmd\fR \fBsaturation\fR \fIvalue\fR
.sp
\fIinstanceCmd\fR \fBsaturation-range\fR
.sp
\fIinstanceCmd\fR \fBsharpness\fR
.sp
\fIinstanceCmd\fR \fBsharpness\fR \fIvalue\fR
.sp
\fIinstanceCmd\fR \fBsharpness-range\fR
.sp
\fIinstanceCmd\fR \fBtilt\fR
.sp
\fIinstanceCmd\fR \fBtilt\fR \fIvalue\fR
.sp
\fIinstanceCmd\fR \fBtilt-range\fR
.sp
\fIinstanceCmd\fR \fBzoom\fR
.sp
\fIinstanceCmd\fR \fBzoom\fR \fIvalue\fR
.sp
\fIinstanceCmd\fR \fBzoom-range\fR
.sp
\fB::kinetcl eventbase\fR \fBnew\fR
.sp
\fB::kinetcl eventbase\fR \fBcreate\fR \fIobjname\fR
.sp
\fIinstanceCmd\fR \fBbind\fR \fIevent\fR \fIcmdprefix\fR
.sp
\fB{*}$cmdprefix\fR \fIevent\fR \fIinstance\fR \fIdetails\fR
.sp
\fIinstanceCmd\fR \fBunbind\fR \fItoken\fR
.sp
\fIinstanceCmd\fR \fBgenerate\fR \fIevent\fR \fIdetails\fR
.sp
\fIinstanceCmd\fR \fBbound\fR
.sp
\fIinstanceCmd\fR \fBunbound\fR
.sp
\fIinstanceCmd\fR \fBevent-bound\fR \fIevent\fR
.sp
\fIinstanceCmd\fR \fBevent-unbound\fR \fIevent\fR
.sp
\fIinstanceCmd\fR \fBRegister\fR \fIevents\fR
.sp
\fB::kinetcl nodeevents\fR \fBnew\fR
.sp
\fB::kinetcl nodeevents\fR \fBcreate\fR \fIobjname\fR
.sp
\fIinstanceCmd\fR \fBSetupEventsOf\fR \fInode\fR
.sp
\fB::kinetcl joints\fR \fBnew\fR ?\fIuser\fR?
.sp
\fB::kinetcl joints\fR \fBcreate\fR \fIobjname\fR ?\fIuser\fR?
.sp
\fIinstanceCmd\fR \fBthreshold\fR
.sp
\fIinstanceCmd\fR \fBthreshold\fR \fIvalue\fR
.sp
\fIinstanceCmd\fR \fBget-generator\fR
.sp
\fIinstanceCmd\fR \fBget-joint\fR \fIuser\fR \fIjoint\fR
.sp
\fIinstanceCmd\fR \fBget-skeleton\fR \fIuser\fR
.sp
\fB::kinetcl stance\fR \fBnew\fR \fIjoints\fR
.sp
\fB::kinetcl stance\fR \fBcreate\fR \fIobjname\fR \fIjoints\fR
.sp
\fIinstanceCmd\fR \fBadd\fR \fIname\fR \fIscript\fR
.sp
\fIinstanceCmd\fR \fBremove\fR \fIname\fR
.sp
\fIinstanceCmd\fR \fBmeasure\fR \fIname\fR \fIscript\fR
.sp
\fBhead\fR
.sp
\fBneck\fR
.sp
\fBtorso\fR
.sp
\fBwaist\fR
.sp
\fBleft-collar\fR
.sp
\fBleft-shoulder\fR
.sp
\fBleft-elbow\fR
.sp
\fBleft-wrist\fR
.sp
\fBleft-hand\fR
.sp
\fBleft-fingertip\fR
.sp
\fBleft-hip\fR
.sp
\fBleft-knee\fR
.sp
\fBleft-ankle\fR
.sp
\fBleft-foot\fR
.sp
\fBright-collar\fR
.sp
\fBright-shoulder\fR
.sp
\fBright-elbow\fR
.sp
\fBright-wrist\fR
.sp
\fBright-hand\fR
.sp
\fBright-fingertip\fR
.sp
\fBright-hip\fR
.sp
\fBright-knee\fR
.sp
\fBright-ankle\fR
.sp
\fBright-foot\fR
.sp
\fBdistance\fR \fIjointa\fR \fIjointb\fR
.sp
\fBdistance_side\fR \fIjointa\fR \fIjointb\fR
.sp
\fBdistance_height\fR \fIjointa\fR \fIjointb\fR
.sp
\fBdistance_depth\fR \fIjointa\fR \fIjointb\fR
.sp
\fBdistance\fR \fIsegment\fR
.sp
\fBdistance_side\fR \fIsegment\fR
.sp
\fBdistance_height\fR \fIsegment\fR
.sp
\fBdistance_depth\fR \fIsegment\fR
.sp
\fBhorizontal_side\fR \fIjointa\fR \fIjointb\fR
.sp
\fBvertical\fR \fIjointa\fR \fIjointb\fR
.sp
\fBhorizontal_depth\fR \fIjointa\fR \fIjointb\fR
.sp
\fBhorizontal_side\fR \fIsegment\fR
.sp
\fBvertical\fR \fIsegment\fR
.sp
\fBhorizontal_depth\fR \fIsegment\fR
.sp
\fBhorizontal_right\fR \fIjointa\fR \fIjointb\fR
.sp
\fBhorizontal_left\fR \fIjointa\fR \fIjointb\fR
.sp
\fBvertical_up\fR \fIjointa\fR \fIjointb\fR
.sp
\fBvertical_down\fR \fIjointa\fR \fIjointb\fR
.sp
\fBhorizontal_backward\fR \fIjointa\fR \fIjointb\fR
.sp
\fBhorizontal_forward\fR \fIjointa\fR \fIjointb\fR
.sp
\fBhorizontal_right\fR \fIsegment\fR
.sp
\fBhorizontal_left\fR \fIsegment\fR
.sp
\fBvertical_up\fR \fIsegment\fR
.sp
\fBvertical_down\fR \fIsegment\fR
.sp
\fBhorizontal_backward\fR \fIsegment\fR
.sp
\fBhorizontal_forward\fR \fIsegment\fR
.sp
\fBright\fR \fIjointa\fR \fIjointb\fR
.sp
\fBleft\fR \fIjointa\fR \fIjointb\fR
.sp
\fBabove\fR \fIjointa\fR \fIjointb\fR
.sp
\fBbelow\fR \fIjointa\fR \fIjointb\fR
.sp
\fBbefore\fR \fIjointa\fR \fIjointb\fR
.sp
\fBbehind\fR \fIjointa\fR \fIjointb\fR
.sp
\fBright\fR \fIsegment\fR
.sp
\fBleft\fR \fIsegment\fR
.sp
\fBabove\fR \fIsegment\fR
.sp
\fBbelow\fR \fIsegment\fR
.sp
\fBbefore\fR \fIsegment\fR
.sp
\fBbehind\fR \fIsegment\fR
.sp
\fBmm\fR \fIx\fR
.sp
\fBcm\fR \fIx\fR
.sp
\fBinch\fR \fIx\fR
.sp
.BE
.SH DESCRIPTION
.PP
Welcome to KineTcl, a binding of the OpenNI framework providing
Tcl with access to MS Kinect (tm), and related sensor systems.
.SH API
.SH "GLOBAL COMMANDS"
This sections documents the global commands in the
\fB::kinetcl\fR namespace and ensemble.
.TP
\fB::kinetcl estart\fR
This command deactivates the event deferal, aka lockout mode.
Any OpenNI/kinetcl events which were prevented from entering Tcl's
event queue are now moved into it.
.sp
The result of the command is the empty string.
.TP
\fB::kinetcl estop\fR
This command activates the event deferal, aka lockout mode.
Any OpenNI/kinetcl events occuring while this mode is active are
prevented from entering Tcl's event queue until the next invokation of
\fB::kinetcl estop\fR.
.sp
The result of the command is the empty string.
.TP
\fB::kinetcl start\fR
This command activates data processing and generation in all known
generator nodes.
.sp
The result of the command is the empty string.
.TP
\fB::kinetcl stop\fR
This command deactivates data processing and generation in all known
generator nodes.
.sp
The result of the command is the empty string.
.TP
\fB::kinetcl waitUpdate\fR
This command waits for all generator nodes to have new data and then
updates them all.
.sp
The result of the command is the empty string.
.TP
\fB::kinetcl waitAnyUpdate\fR
This command waits for any of the generator nodes to have new data and
then updates them all.
.sp
The result of the command is the empty string.
.TP
\fB::kinetcl waitNoneUpdate\fR
This command updates all generator nodes, without any waiting.
.sp
The result of the command is the empty string.
.TP
\fB::kinetcl waitOneUpdate\fR \fInode\fR
This command waits for the specified generator \fInode\fR to have new
data and then updates all nodes.
.sp
The result of the command is the empty string.
.TP
\fB::kinetcl errorstate\fR
This command returns the global error state of OpenNI as string.
.TP
\fB::kinetcl mirror\fR ?\fIbool\fR?
This command returns the current value of the global mirror flag.
If the argument is specified the global mirror flag is set to its
value, and all existing nodes supporting mirroring are reconfigured to
reflect the new state.
.PP
.SH BASE
This sections documents the class \fB::kinetcl base\fR, the (abstract) base
class for all OpenNI production nodes.
.PP
This class actually inherits from \fB::kinetcl nodeevents\fR
for the management of events generated by OpenNI node instances. See
section \fBNode Events\fR.
.PP
They may have the following capabilities:
.IP [1]
\fBBacklight Compensation\fR
.IP [2]
\fBBrightness\fR
.IP [3]
\fBColor Temperature\fR
.IP [4]
\fBContrast\fR
.IP [5]
\fBExposure\fR
.IP [6]
\fBFocus\fR
.IP [7]
\fBGain\fR
.IP [8]
\fBGamma\fR
.IP [9]
\fBHue\fR
.IP [10]
\fBIris\fR
.IP [11]
\fBLowlight compensation\fR
.IP [12]
\fBPan\fR
.IP [13]
\fBRoll\fR
.IP [14]
\fBSaturation\fR
.IP [15]
\fBSharpness\fR
.IP [16]
\fBTilt\fR
.IP [17]
\fBZoom\fR
.PP
.SS "CLASS API"
.TP
\fB::kinetcl base\fR \fBnew\fR
.TP
\fB::kinetcl base\fR \fBcreate\fR \fIobjname\fR
This command creates a new instance of the node base.
Note that it is \fIimpossible\fR to create such an instance on its
own. It can be done only as part of constructing the instance of a
concrete class.
The API provided by the instance, i.e. the set of available methods
and their semantics is described in the next subsection.
.PP
.SS "INSTANCE API"
.TP
\fIbaseInstanceCmd\fR \fBcapabilities\fR ?\fB-all\fR?
This method returns the capabilities of the instance, or, if option
\fB-all\fR was specified, the set of all possible capabilities.
.sp
The result is a list containing the names of the capabilities.
.TP
\fIbaseInstanceCmd\fR \fBis-capable-of\fR \fIcapability\fR
This method checks if the named capability is supported by the
instance or not.
.sp
The result is a boolean value, \fBtrue\fR if the capability
is supported, and \fBfalse\fR else.
.TP
\fIbaseInstanceCmd\fR \fBnode-info\fR
This method returns a dictionary containing OpenNI's description of the
node. They keys of the dictinary, and the associated values are
.RS
.TP
\fBtype\fR
The OpenNI type of the node, which is either one of
.RS
.IP \(bu
invalid
.IP \(bu
device
.IP \(bu
depth
.IP \(bu
image
.IP \(bu
audio
.IP \(bu
ir
.IP \(bu
user
.IP \(bu
recorder
.IP \(bu
player
.IP \(bu
gesture
.IP \(bu
scene
.IP \(bu
hands
.IP \(bu
codec
.IP \(bu
production
.IP \(bu
generator
.IP \(bu
map
.IP \(bu
script
.RE
.IP
or an integer number. The latter is used for unknown custom types
OpenNI has no name for.
.TP
\fBvendor\fR
The name of the vendor supplying the library which implements the
node.
.TP
\fBname\fR
The name OpenNI has given to the node. This is the same as returned by
method \fBnode-name\fR.
.TP
\fBversion\fR
The version of the library implementing the node (see also the key
\fBvendor\fR) as a 4-element list containing major, minor version
number, maintenance id, and build number, in this order.
.TP
\fBcreate\fR
The node's creation detail information.
.RE
.TP
\fIbaseInstanceCmd\fR \fBnode-name\fR
This method returns a string holding the OpenNI name of the node.
.TP
\fIbaseInstanceCmd\fR \fBbind\fR \fIevent\fR \fIcommand\fR
This method associates the given \fIcommand\fR prefix with the named
\fIevent\fR and arranges for the execution of the command prefix when
the event in question occurs.
.sp
The result of the method is an opaque token representing the
binding. It can only be used as argument of method \fBunbind\fR,
see below, to remove the binding again.
.sp
The command prefix is expected to have the following signature:
.RS
.TP
\fB{*}command\fR \fIevent\fR \fIobj\fR \fIdetails\fR
.RS
\fIevent\fR
The name of the event itself, allowing it to be used as sub-method name.
\fIobj\fR
The name of the instance generating the event.
\fIdetails\fR
A dictionary holding more information about the event. The set of keys
and their values depends on the event itself and is described with the
event. See the sections named \fBEvents\fR, at all the classes
supporting one or more events.
.RE
.RE
.IP
Each event supported by a specific node class is explained in the
documentation of that class.
.TP
\fIbaseInstanceCmd\fR \fBunbind\fR \fItoken\fR
This method takes a \fItoken\fR as returned by method \fBbind\fR
(see above), and removes the binding it represents. Afterward the
command prefix from \fBbind\fR is not invoked anymore when the
event the binding was for occurs.
.sp
The result of the method is an empty string.
.PP
.SH GENERATOR
This sections documents the class \fB::kinetcl generator\fR, the (abstract) base
class for all OpenNI generator nodes.
.PP
This class inherits from \fB::kinetcl base\fR. See section
\fBBase\fR.
.PP
They may have the following capabilities:
.IP [1]
\fBAlternative Viewpoint\fR
.IP [2]
\fBFrame Synchronization\fR
.IP [3]
\fBMirror\fR
.PP
.SS "CLASS API"
.TP
\fB::kinetcl generator\fR \fBnew\fR
.TP
\fB::kinetcl generator\fR \fBcreate\fR \fIobjname\fR
This command creates a new instance of the generator.
Note that it is \fIimpossible\fR to create such an instance on its
own. It can be done only as part of constructing the instance of a
concrete class.
The API provided by the instance, i.e. the set of available methods
and their semantics is described in the next subsection.
.PP
.SS "INSTANCE API"
.TP
\fIgeneratorInstanceCmd\fR \fBstart\fR
This method causes the instance to start generating output. It implies
the activation of all dependencies as well.
.sp
The result of the method is the empty string.
.TP
\fIgeneratorInstanceCmd\fR \fBstop\fR
This method causes the instance to stop generating output.
.sp
The result of the method is the empty string.
.TP
\fIgeneratorInstanceCmd\fR \fBactive\fR
This method tests if the instance is generating output.
.sp
The result of the method is a boolean value, \fBtrue\fR if the
instance is generating output, and \fBfalse\fR else.
.TP
\fIgeneratorInstanceCmd\fR \fBupdate\fR
This method causes the instance to update its output to the newest
available. If no new output was available the method blocks until this
happens.
.sp
The result of the method is the empty string.
.TP
\fIgeneratorInstanceCmd\fR \fBhasNew\fR
This method tests if the instance has new output available it could be
updated to.  I.e. it checks if the method \fBupdate\fR would block
or not.
.sp
The result of the method is a boolean value, \fBtrue\fR if
the instance has new data (i.e. \fBupdate\fR would not block), and
\fBfalse\fR else.
.TP
\fIgeneratorInstanceCmd\fR \fBisNew\fR
This method tests if the instance's current input frame is new,
i.e. unchanged since the last call to method \fBupdate\fR.
.sp
The result of the method is a boolean value, \fBtrue\fR if
the instance if the current frame is still new, and \fBfalse\fR
else.
.sp
The result of the method is the empty string.
.TP
\fIgeneratorInstanceCmd\fR \fBframe\fR
This method returns the id of the input frame currently handled by the
instance.
.sp
The result of the method is an integer number.
.TP
\fIgeneratorInstanceCmd\fR \fBtime\fR
This method returns the time of the input frame currently handled by
the instance, in microseconds.
.sp
The result of the method is an integer number.
.PP
.SS EVENTS
This class supports the events below. These names can be used as the
\fIevent\fR argument of method \fBbind\fR defined by our super-class
\fB::kinetcl::base\fR.
.TP
\fBactive\fR
This event is generated in response to activity changes, i.e. the instance starting and stopping the generation of output.
.sp
The detail dictionary of this event is empty.
.sp
\fINote\fR that events are not told the actual state of the
instance. If this information is required then it is the receiver's
responsibility to query the state using the appropriate query methods.
.PP
.TP
\fBnewdata\fR
This event is generated in response to the availability of new data, i.e the instance having new output available for the user.
.sp
The detail dictionary of this event is empty.
.sp
\fINote\fR that events are not told the actual state of the
instance. If this information is required then it is the receiver's
responsibility to query the state using the appropriate query methods.
.PP
.SH "MAP GENERATOR"
This sections documents the class \fB::kinetcl map\fR, the (abstract) base
class for all OpenNI map generator nodes.
.PP
This class inherits from \fB::kinetcl generator\fR and its
superclasses. See section \fBGenerator\fR.
.PP
They may have the following capabilities:
.IP [1]
\fBAnti-Flicker\fR
.IP [2]
\fBCropping\fR
.PP
.SS "CLASS API"
.TP
\fB::kinetcl map\fR \fBnew\fR
.TP
\fB::kinetcl map\fR \fBcreate\fR \fIobjname\fR
This command creates a new instance of the map generator.
Note that it is \fIimpossible\fR to create such an instance on its
own. It can be done only as part of constructing the instance of a
concrete class.
The API provided by the instance, i.e. the set of available methods
and their semantics is described in the next subsection.
.PP
.SS "INSTANCE API"
.TP
\fImapInstanceCmd\fR \fBbytes-per-pixel\fR
This method returns the number of bytes per pixel in the map.
.TP
\fImapInstanceCmd\fR \fBmodes\fR
This method returns the map output modes supported by the instance.
.sp
The result of the method is a list of modes. Each mode is a
3-element list reporting the x- and y-resolution of the map in pixels,
and the associated frame rate in frames per second, in this order. All
elements are integer numbers.
.TP
\fImapInstanceCmd\fR \fBmode\fR
This form of the method reports the currently set map output mode.
.sp
The result of the method is a 3-element list reporting the x-
and y-resolution of the map in pixels, and the associated frame rate
in frames per second, in this order. All elements are integer numbers.
.TP
\fImapInstanceCmd\fR \fBmode\fR \fIxres\fR \fIyres\fR \fIfps\fR
This form of the method changes the map output mode to the specified
resolution and frame rate. The method throws an error if the
combination is not supported by the instance.
.sp
The result of the method is an empty string.
.PP
.SS EVENTS
This class supports the events below. These names can be used as the
\fIevent\fR argument of method \fBbind\fR defined by our super-class
\fB::kinetcl::base\fR.
.TP
\fBmode\fR
This event is generated in response to mode changes, i.e. reconfiguration of the instance's output mode.
.sp
The detail dictionary of this event is empty.
.sp
\fINote\fR that events are not told the actual state of the
instance. If this information is required then it is the receiver's
responsibility to query the state using the appropriate query methods.
.PP
.SH "DEPTH GENERATOR"
This sections documents the class \fB::kinetcl generator\fR, the
concrete class for all OpenNI depth generator nodes.
.PP
This class inherits from \fB::kinetcl generator\fR and its
superclasses. See section \fBGenerator\fR.
.PP
A depth generator is a generator providing depth maps,
i.e. images where each pixel value describes the distance of the pixel
from the sensor.
.SS "CLASS API"
.TP
\fB::kinetcl depth\fR \fBnew\fR
.TP
\fB::kinetcl depth\fR \fBcreate\fR \fIobjname\fR
This command creates a new depth generator instance and returns the
fully qualified name of the instance command. The API provided by that
command, i.e. the set of available methods and their semantics is
described in the next subsection.
.PP
.SS "INSTANCE API"
.TP
\fIdepthInstanceCmd\fR \fBdestroy\fR
This method destroys the depth generator instance and releases all
associated resources, including the instance command. Note that
resources used by multiple instances are released only when the last
instance using them is destroyed.
.sp
The result of the method is the empty string.
.TP
\fIdepthInstanceCmd\fR \fBmax-depth\fR
This method returns the max depth the node is able to generate. The
result is an integer number.
.TP
\fIdepthInstanceCmd\fR \fBfov\fR
This method returns the field of view the node is able to generate, in
radians. The result is a 2-element list containing the horizontal and
vertical fields of view, in this order.
.TP
\fIdepthInstanceCmd\fR \fBmeta\fR
This method returns a dictionary holding information about the depth
maps produced by the node. The keys found in this dictionary, and the
associated values are:
.RS
.TP
\fBmap\fR
The value is a dictionary holding information about the map produced
by the node. The keys found in this dictionary, and the associated
values are:
.RS
.TP
\fBformat\fR
The pixel format of the depth maps produced by the node.
The possible values are:
.RS
.TP
\fBrgb24\fR
3 bytes/pixel red/green/blue.
.TP
\fByuv422\fR
Lumincance/2-Chroma, chroma in reduced horizontal resolution.
.TP
\fBgrey8\fR
1 byte/pixel, 256 grey levels.
.TP
\fBgrey16\fR
2 byte/pixel, 65536 grey levels, depths, or labels.
.TP
\fBmjpeg\fR
Motion JPEG compressed image.
.RE
.sp
The formats \fByuv422\fR and \fBmjpeg\fR are not supported
by \fBkinetcl\fR.
.TP
\fBfps\fR
The frame rate of the node, in frames per second.
.TP
\fBfullres\fR
The full resolution of the produced depth maps. The value is a
2-element list containing the horizontal and vertical resolution in
pixels, in this order.
.TP
\fBoffset\fR
The location of the produced depth map within the full depth map. The
value is a 2-element list containing the horizontal and vertical
position in pixels, in this order.
This can differ from \fB{0 0}\fR if and only if cropping is
active.
.TP
\fBoutput\fR
The value is a dictionary holding information about the output
produced by the node. The keys found in this dictionary, and the
associated values are:
.RS
.TP
\fBframe\fR
The id of the current frame.
.TP
\fBnew\fR
The \fBisNew\fR flag of the current frame.
.TP
\fBsize\fR
The size of the frame, in bytes. Together with the resolution of the
frame we can compute the number of bytes per pixel in the map.
.TP
\fBtime\fR
The time-code of the current frame.
.RE
.TP
\fBres\fR
The current resolution of the produced depth maps. This may be less
than the full resolution (see above), if cropping is active. The
value is a 2-element list containing the horizontal and vertical
resolution in pixels, in this order.
.RE
.TP
\fBmax-depth\fR
The max depth the node is able to generate. An integer number.
This is the same value as returned by method \fBmax-depth\fR.
.RE
.IP
Notes:
.sp
Depth maps are in pixel format \fBgrey16\fR.
.TP
\fIdepthInstanceCmd\fR \fBmap\fR
This method returns a \fBcrimp\fR image of type \fBgrey16\fR
where the value of each pixel represents the distance of the pixel
from the sensor, in millimeters.
.TP
\fIdepthInstanceCmd\fR \fBprojective2world\fR \fIpoint\fR...
This method converts one or more 3D points from sensor coordinates to
real world coordinates.
.sp
The result of the method is a list holding the conversion
results. Each point in both arguments and result is a 3-element list
containing the point's X-, Y-, and Z-coordinates, in this order.
.TP
\fIdepthInstanceCmd\fR \fBworld2projective\fR \fIpoint\fR...
This method converts one or more 3D points from real world coordinates
to sensor coordinates.
.sp
The result of the method is a list holding the conversion
results. Each point in both arguments and result is a 3-element list
containing the point's X-, Y-, and Z-coordinates, in this order.
.PP
.SS EVENTS
This class supports the events below. These names can be used as the
\fIevent\fR argument of method \fBbind\fR defined by our super-class
\fB::kinetcl::base\fR.
.TP
\fBdepthfov\fR
This event is generated in response to depthfov changes, i.e. reconfiguration of the device's field of view.
.sp
The detail dictionary of this event is empty.
.sp
\fINote\fR that events are not told the actual state of the
instance. If this information is required then it is the receiver's
responsibility to query the state using the appropriate query methods.
.PP
.SH "IMAGE GENERATOR"
This sections documents the class \fB::kinetcl image\fR, the
concrete class for all OpenNI image generator nodes.
.PP
This class inherits from \fB::kinetcl map\fR and its
superclasses. See section \fBMap Generator\fR.
.PP
An image generator is a map generator providing plain images,
where each pixel value describes the color (or luminance) of the pixel.
.SS "CLASS API"
.TP
\fB::kinetcl image\fR \fBnew\fR
.TP
\fB::kinetcl image\fR \fBcreate\fR \fIobjname\fR
This command creates a new image generator instance and returns the
fully qualified name of the instance command. The API provided by that
command, i.e. the set of available methods and their semantics is
described in the next subsection.
.PP
.SS "INSTANCE API"
.TP
\fIimageInstanceCmd\fR \fBdestroy\fR
This method destroys the image generator instance and releases all
associated resources, including the instance command. Note that
resources used by multiple instances are released only when the last
instance using them is destroyed.
.sp
The result of the method is the empty string.
.TP
\fIimageInstanceCmd\fR \fBformats\fR
This method returns a list of the pixel formats supported by the node.
.sp
For the list of possible pixel formats see below, under method
\fBmeta\fR.
.TP
\fIimageInstanceCmd\fR \fBformat\fR ?\fIformat\fR?
This method returns the name of the currently active pixel format.
If the argument \fIformat\fR is present the node is reconfigured to
report the images in the specified format.
.sp
For the list of possible pixel formats see below, under method
\fBmeta\fR.
.TP
\fIimageInstanceCmd\fR \fBmeta\fR
This method returns a dictionary holding information about the image
maps produced by the node. The keys found in this dictionary, and the
associated values are:
.RS
.TP
\fBmap\fR
The value is a dictionary holding information about the map produced
by the node. The keys found in this dictionary, and the associated
values are:
.RS
.TP
\fBformat\fR
The pixel format of the depth maps produced by the node.
The possible values are:
.RS
.TP
\fBrgb24\fR
3 bytes/pixel red/green/blue.
.TP
\fByuv422\fR
Lumincance/2-Chroma, chroma in reduced horizontal resolution.
.TP
\fBgrey8\fR
1 byte/pixel, 256 grey levels.
.TP
\fBgrey16\fR
2 byte/pixel, 65536 grey levels, depths, or labels.
.TP
\fBmjpeg\fR
Motion JPEG compressed image.
.RE
.sp
The formats \fByuv422\fR and \fBmjpeg\fR are not supported
by \fBkinetcl\fR.
.TP
\fBfps\fR
The frame rate of the node, in frames per second.
.TP
\fBfullres\fR
The full resolution of the produced depth maps. The value is a
2-element list containing the horizontal and vertical resolution in
pixels, in this order.
.TP
\fBoffset\fR
The location of the produced depth map within the full depth map. The
value is a 2-element list containing the horizontal and vertical
position in pixels, in this order.
This can differ from \fB{0 0}\fR if and only if cropping is
active.
.TP
\fBoutput\fR
The value is a dictionary holding information about the output
produced by the node. The keys found in this dictionary, and the
associated values are:
.RS
.TP
\fBframe\fR
The id of the current frame.
.TP
\fBnew\fR
The \fBisNew\fR flag of the current frame.
.TP
\fBsize\fR
The size of the frame, in bytes. Together with the resolution of the
frame we can compute the number of bytes per pixel in the map.
.TP
\fBtime\fR
The time-code of the current frame.
.RE
.TP
\fBres\fR
The current resolution of the produced depth maps. This may be less
than the full resolution (see above), if cropping is active. The
value is a 2-element list containing the horizontal and vertical
resolution in pixels, in this order.
.RE
.RE
.IP
Notes:
.sp
Image maps are usually in pixel format \fBrgb24\fR.
.TP
\fIimageInstanceCmd\fR \fBmap\fR
This method returns a \fBcrimp\fR image containing the current
image map. The crimp type of the image depends on the currently active
pixel format:
.RS
.TP
\fBrgb24\fR
--> \fBrgb\fR
.TP
\fBgrey8\fR
--> \fBgrey8\fR
.TP
\fBgrey16\fR
--> \fBgrey16\fR
.RE
.PP
.SS EVENTS
This class supports the events below. These names can be used as the
\fIevent\fR argument of method \fBbind\fR defined by our super-class
\fB::kinetcl::base\fR.
.TP
\fBpixelformat\fR
This event is generated in response to changes of the pixel format used for the images generated by the instance.
.sp
The detail dictionary of this event is empty.
.sp
\fINote\fR that events are not told the actual state of the
instance. If this information is required then it is the receiver's
responsibility to query the state using the appropriate query methods.
.PP
.SH "IR GENERATOR"
This sections documents the class \fB::kinetcl ir\fR, the
concrete class for all OpenNI IR image generator nodes.
.PP
This class inherits from \fB::kinetcl map\fR and its
superclasses. See section \fBMap Generator\fR.
.PP
An IR image generator is a map generator providing infrared
images.
.SS "CLASS API"
.TP
\fB::kinetcl ir\fR \fBnew\fR
.TP
\fB::kinetcl ir\fR \fBcreate\fR \fIobjname\fR
This command creates a new ir image generator instance and returns the
fully qualified name of the instance command. The API provided by that
command, i.e. the set of available methods and their semantics is
described in the next subsection.
.PP
.SS "INSTANCE API"
.TP
\fIirIstanceCmd\fR \fBdestroy\fR
This method destroys the ir image generator instance and releases all
associated resources, including the instance command. Note that
resources used by multiple instances are released only when the last
instance using them is destroyed.
.sp
The result of the method is the empty string.
.PP
.SH "GESTURE GENERATOR"
This sections documents the class \fB::kinetcl gesture\fR, the
concrete class for all OpenNI gesture generator nodes.
.PP
This class inherits from \fB::kinetcl generator\fR and its
superclasses. See section \fBGenerator\fR.
.PP
A genestur generator identifies and tracks gestures performed
by the users within the field of view of the sensor.
.SS "CLASS API"
.TP
\fB::kinetcl gesture\fR \fBnew\fR
.TP
\fB::kinetcl gesture\fR \fBcreate\fR \fIobjname\fR
This command creates a new gesture generator instance and returns the
fully qualified name of the instance command. The API provided by that
command, i.e. the set of available methods and their semantics is
described in the next subsection.
.PP
.SS "INSTANCE API"
.TP
\fIgestureInstanceCmd\fR \fBdestroy\fR
This method destroys the gesture generator instance and releases all
associated resources, including the instance command. Note that
resources used by multiple instances are released only when the last
instance using them is destroyed.
.sp
The result of the method is the empty string.
.TP
\fIgestureInstanceCmd\fR \fBadd-gesture\fR \fIgesture\fR ?\fIbox\fR?
This method activates the gesture, i.e. causes the instance to start
looking for it in the input.
.sp
The \fIbox\fR describes the area where to look for it, in
real-world coordinates. It is a 2-element list of 3-element lists of
x-, y-, and z-coordinates. The 1st 3D coordinate describes the
left-bottom-near corner of the box, whereas the 2nd describes the
right-top-far corner.
.sp
If not specified the box encompasses the whole field of view.
.sp
The result of the method is the empty string.
.TP
\fIgestureInstanceCmd\fR \fBremove-gesture\fR \fIgesture\fR
This method deactivates the gesture, i.e. causes the instance to stop
looking for it in the input.
.sp
The result of the method is the empty string.
.TP
\fIgestureInstanceCmd\fR \fBis-gesture\fR \fIgesture\fR
This method tests if the named \fIgesture\fR is supported by the instance.
.sp
The result is a boolean value, \fBtrue\fR if the gesture is
supported, and \fBfalse\fR else.
.TP
\fIgestureInstanceCmd\fR \fBgesture-has-progress\fR \fIgesture\fR
This method tests if the named \fIgesture\fR supports progess
reporting during recognition.
.sp
The result is a boolean value, \fBtrue\fR if the gesture
supports progress reporting, and \fBfalse\fR else.
.TP
\fIgestureInstanceCmd\fR \fBall-gestures\fR
This method returns a list containing the names of all gestures
supported by the instance.
.TP
\fIgestureInstanceCmd\fR \fBactive-gestures\fR
This method returns a list containing the names of all gestures
that are currently active.
.PP
.SS EVENTS
This class supports the events below. These names can be used as the
\fIevent\fR argument of method \fBbind\fR defined by our super-class
\fB::kinetcl::base\fR.
.TP
\fBgesture-recognized\fR
This event is generated in response to the recognition of named a gesture.
.sp
The detail dictionary of this event contains:
.RS
.TP
\fIgesture\fR
The name of the gesture which was recognized
.TP
\fIid_position\fR
The position where the gesture was recognized. This is a 3-element
list of floating point values containing the \fIreal world\fR
x-, y-, and z-coordinates of the position, in this order.
.TP
\fIend_position\fR
The position of the hand at the end of the gesture. This is a
3-element list of floating point values containing the
\fIreal world\fR x-, y-, and z-coordinates of the position, in this
order.
.RE
.sp
\fINote\fR that events are not told the actual state of the
instance. If this information is required then it is the receiver's
responsibility to query the state using the appropriate query methods.
.PP
.TP
\fBgesture-progress\fR
This event is generated in response to the system's progress in recognizing a gesture.
.sp
The detail dictionary of this event contains:
.RS
.TP
\fIgesture\fR
The name of the gesture whose recognition is in progress.
.TP
\fIposition\fR
The current position of the hand performing the gesture. This is a
3-element list of floating point values containing the
\fIreal world\fR x-, y-, and z-coordinates of the position, in this
order.
.TP
\fIpercent\fR
The percentage of the gesture already performed.
.RE
.sp
\fINote\fR that events are not told the actual state of the
instance. If this information is required then it is the receiver's
responsibility to query the state using the appropriate query methods.
.PP
.TP
\fBgesture\fR
This event is generated in response to the (de)activation of the recognition of named gestures.
.sp
The detail dictionary of this event is empty.
.sp
\fINote\fR that events are not told the actual state of the
instance. If this information is required then it is the receiver's
responsibility to query the state using the appropriate query methods.
.PP
.TP
\fBgesture-stage-complete\fR
This event is generated in response to the completion of stages in a gesture's recognition.
.sp
The detail dictionary of this event contains:
.RS
.TP
\fIgesture\fR
The name of the gesture whose recognition is in progress.
.TP
\fIposition\fR
The current position of the hand performing the gesture. This is a
3-element list of floating point values containing the
\fIreal world\fR x-, y-, and z-coordinates of the position, in this
order.
.RE
.sp
\fINote\fR that events are not told the actual state of the
instance. If this information is required then it is the receiver's
responsibility to query the state using the appropriate query methods.
.PP
.TP
\fBgesture-stage-ready-for-next\fR
This event is generated in response to the system's readiness to enter the next stage in the recognition of a gesture.
.sp
The detail dictionary of this event contains:
.RS
.TP
\fIgesture\fR
The name of the gesture whose recognition is in progress.
.TP
\fIposition\fR
The current position of the hand performing the gesture. This is a
3-element list of floating point values containing the
\fIreal world\fR x-, y-, and z-coordinates of the position, in this
order.
.RE
.sp
\fINote\fR that events are not told the actual state of the
instance. If this information is required then it is the receiver's
responsibility to query the state using the appropriate query methods.
.PP
.SH "SCENE ANALYZER"
This sections documents the class \fB::kinetcl scene\fR, the concrete
class for all OpenNI scene analyzer nodes.
.PP
This class inherits from \fB::kinetcl map\fR and its
superclasses. See section \fBMap Generator\fR.
.PP
A scene analyzer segments a scene, identifying the floor and
other connected areas (i.e. users) in the view of the sensor.
.SS "CLASS API"
.TP
\fB::kinetcl scene\fR
This command creates a new scene analyzer instance and returns the
fully qualified name of the instance command. The API provided by that
command, i.e. the set of available methods and their semantics is
described in the next subsection.
.PP
.SS "INSTANCE API"
.TP
\fIsceneInstanceCmd\fR \fBdestroy\fR
This method destroys the scene analyzer instance and releases all
associated resources, including the instance command.  Note that
resources used by multiple instances are released only when the last
instance using them is destroyed.
.sp
The result of the method is the empty string.
.TP
\fIsceneInstanceCmd\fR \fBmeta\fR
This method returns a dictionary holding information about the scene
segmentation produced by the node. The keys found in this dictionary,
and the associated values are:
.RS
.TP
\fBmap\fR
The value is a dictionary holding information about the map produced
by the node. The keys found in this dictionary, and the associated
values are:
.RS
.TP
\fBformat\fR
The pixel format of the depth maps produced by the node.
The possible values are:
.RS
.TP
\fBrgb24\fR
3 bytes/pixel red/green/blue.
.TP
\fByuv422\fR
Lumincance/2-Chroma, chroma in reduced horizontal resolution.
.TP
\fBgrey8\fR
1 byte/pixel, 256 grey levels.
.TP
\fBgrey16\fR
2 byte/pixel, 65536 grey levels, depths, or labels.
.TP
\fBmjpeg\fR
Motion JPEG compressed image.
.RE
.sp
The formats \fByuv422\fR and \fBmjpeg\fR are not supported
by \fBkinetcl\fR.
.TP
\fBfps\fR
The frame rate of the node, in frames per second.
.TP
\fBfullres\fR
The full resolution of the produced depth maps. The value is a
2-element list containing the horizontal and vertical resolution in
pixels, in this order.
.TP
\fBoffset\fR
The location of the produced depth map within the full depth map. The
value is a 2-element list containing the horizontal and vertical
position in pixels, in this order.
This can differ from \fB{0 0}\fR if and only if cropping is
active.
.TP
\fBoutput\fR
The value is a dictionary holding information about the output
produced by the node. The keys found in this dictionary, and the
associated values are:
.RS
.TP
\fBframe\fR
The id of the current frame.
.TP
\fBnew\fR
The \fBisNew\fR flag of the current frame.
.TP
\fBsize\fR
The size of the frame, in bytes. Together with the resolution of the
frame we can compute the number of bytes per pixel in the map.
.TP
\fBtime\fR
The time-code of the current frame.
.RE
.TP
\fBres\fR
The current resolution of the produced depth maps. This may be less
than the full resolution (see above), if cropping is active. The
value is a 2-element list containing the horizontal and vertical
resolution in pixels, in this order.
.RE
.RE
.IP
Notes:
.sp
Scene segmentations are in pixel format \fBgrey16\fR.
.TP
\fIsceneInstanceCmd\fR \fBmap\fR
This method returns a \fBcrimp\fR image of type \fBgrey16\fR
containing the current scene segmentation. Each pixel is labeled with
the id of the user it belongs to, or \fB0\fR if it is background.
.TP
\fIsceneInstanceCmd\fR \fBfloor\fR
This method returns a dictionary describing the floor, as a
combination of a point on the floor, plus the normal vector to specify
orientation. The two keys in the dictionary are
.RS
.TP
\fBpoint\fR
A point on the floor, in \fIreal world\fR coordinates. The value is
a 3-element list containing the x-, y-, and z-coordinates, in this
order.
.TP
\fBnormal\fR
The normal vector describing the orientation. The value is a 3-element
list containing the \fIreal world\fR x-, y-, and z-coordinates, in
this order.
.RE
.PP
.SH "USER GENERATOR"
This sections documents the class \fB::kinetcl user\fR, the concrete
class for all OpenNI user generator nodes.
.PP
This class inherits from \fB::kinetcl generator\fR and its
superclasses. See section \fBGenerator\fR.
.PP
A user generator identifies and tracks users within the field
of view of the sensor.
.PP
They may have the following capabilities:
.IP [1]
\fBPose Detection\fR
.IP [2]
\fBHand Touching FOV Edge\fR
.IP [3]
\fBSkeleton/Joint Tracking\fR
.PP
.SS "CLASS API"
.TP
\fB::kinetcl user\fR \fBnew\fR
.TP
\fB::kinetcl user\fR \fBcreate\fR \fIobjname\fR
This command creates a new user generator instance and returns the
fully qualified name of the instance command. The API provided by that
command, i.e. the set of available methods and their semantics is
described in the next subsection.
.PP
.SS "INSTANCE API"
.TP
\fIuserInstanceCmd\fR \fBdestroy\fR
This method destroys the user generator instance and releases all
associated resources, including the instance command. Note that
resources used by multiple instances are released only when the last
instance using them is destroyed.
.sp
The result of the method is the empty string.
.TP
\fIuserInstanceCmd\fR \fBcount\fR
This method returns the number of users currently tracked by the
user generator instance.
.TP
\fIuserInstanceCmd\fR \fBusers\fR
This method returns a list containing the ids of the users currently
tracked by the user generator instance.
.TP
\fIuserInstanceCmd\fR \fBcenterof\fR \fIid\fR
This method returns the center location for the user specified by its
id, as a 3-element list, i.e. vector, of floating point coordinates.
The coordinates are specified in the order of X, Y, and Z.
.sp
The method will throw an error if the user id is not valid.
.TP
\fIuserInstanceCmd\fR \fBpixelsof\fR \fIid\fR
This method returns a \fBcrimp\fR image of type \fBgrey16\fR
where all pixels representing the user are set to the user's id, and
everything else set to \fB0\fR.
.PP
.SS EVENTS
This class supports the events below. These names can be used as the
\fIevent\fR argument of method \fBbind\fR defined by our super-class
\fB::kinetcl::base\fR.
.TP
\fBuser-enter\fR
This event is generated in response to a user re-entering the scene.
.sp
The detail dictionary of this event contains:
.RS
.TP
\fIuser\fR
The numerical id of the user the event was generated for.
.RE
.sp
\fINote\fR that events are not told the actual state of the
instance. If this information is required then it is the receiver's
responsibility to query the state using the appropriate query methods.
.PP
.TP
\fBuser-exit\fR
This event is generated in response to a user existing the scene.
.sp
The detail dictionary of this event contains:
.RS
.TP
\fIuser\fR
The numerical id of the user the event was generated for.
.RE
.sp
\fINote\fR that events are not told the actual state of the
instance. If this information is required then it is the receiver's
responsibility to query the state using the appropriate query methods.
.PP
.TP
\fBuser-new\fR
This event is generated in response to the recognition of a new user.
.sp
The detail dictionary of this event contains:
.RS
.TP
\fIuser\fR
The numerical id of the user the event was generated for.
.RE
.sp
\fINote\fR that events are not told the actual state of the
instance. If this information is required then it is the receiver's
responsibility to query the state using the appropriate query methods.
.PP
.TP
\fBuser-lost\fR
This event is generated in response to the loss of a user (after exiting the scene).
.sp
The detail dictionary of this event contains:
.RS
.TP
\fIuser\fR
The numerical id of the user the event was generated for.
.RE
.sp
\fINote\fR that events are not told the actual state of the
instance. If this information is required then it is the receiver's
responsibility to query the state using the appropriate query methods.
.PP
.SH "HANDS GENERATOR"
This sections documents the class \fB::kinetcl hands\fR, the concrete
class for all OpenNI hand generator nodes.
.PP
This class inherits from \fB::kinetcl generator\fR and its
superclasses. See section \fBGenerator\fR.
.PP
A hand generator identifies and tracks the hands of the users
within the field of view of the sensor.
.SS "CLASS API"
.TP
\fB::kinetcl hands\fR \fBnew\fR
.TP
\fB::kinetcl hands\fR \fBcreate\fR \fIobjname\fR
This command creates a new hands generator instance and returns the
fully qualified name of the instance command. The API provided by that
command, i.e. the set of available methods and their semantics is
described in the next subsection.
.PP
.SS "INSTANCE API"
.TP
\fIhandsInstanceCmd\fR \fBdestroy\fR
This method destroys the hands generator instance and releases all
associated resources, including the instance command. Note that
resources used by multiple instances are released only when the last
instance using them is destroyed.
.sp
The result of the method is the empty string.
.TP
\fIinstanceCmd\fR \fBset-smoothing\fR \fIfactor\fR
This method sets the smoothing \fIfactor\fR for hand tracking, a
floating point value between \fB0\fR and \fB1\fR. The former
disables smoothing, the latter implies infinite smoothing.
.sp
The result of the method is an empty string.
.TP
\fIinstanceCmd\fR \fBstart-tracking\fR \fIpoint\fR
This method activates the tracking of a hand at the \fIpoint\fR.
The point must be a 3-element list containing the X, Y, and Z
coordinates, in this order.
.sp
The result of the method is an empty string.
.TP
\fIinstanceCmd\fR \fBstop-tracking\fR \fIid\fR
This method stops tracking of the hand specified by the \fIid\fR.
.sp
The result of the method is an empty string.
.TP
\fIinstanceCmd\fR \fBstop-tracking-all\fR
This method stops the tracking of all hands known to the node.
.sp
The result of the method is an empty string.
.PP
.SS EVENTS
This class supports the events below. These names can be used as the
\fIevent\fR argument of method \fBbind\fR defined by our super-class
\fB::kinetcl::base\fR.
.TP
\fBhand-create\fR
This event is generated in response to the creation of a new tracked hand.
.sp
The detail dictionary of this event contains:
.RS
.TP
\fIhand\fR
The id of the tracked hand.
.TP
\fIposition\fR
The position of the hand. This is a 3-element list of floating point
values containing the \fIreal world\fR x-, y-, and z-coordinates of
the position, in this order.
.TP
\fItime\fR
A timestamp.
.RE
.sp
\fINote\fR that events are not told the actual state of the
instance. If this information is required then it is the receiver's
responsibility to query the state using the appropriate query methods.
.PP
.TP
\fBhand-update\fR
This event is generated in response to the movement of an existing tracked hand.
.sp
The detail dictionary of this event contains:
.RS
.TP
\fIhand\fR
The id of the tracked hand.
.TP
\fIposition\fR
The position of the hand. This is a 3-element list of floating point
values containing the \fIreal world\fR x-, y-, and z-coordinates of
the position, in this order.
.TP
\fItime\fR
A timestamp.
.RE
.sp
\fINote\fR that events are not told the actual state of the
instance. If this information is required then it is the receiver's
responsibility to query the state using the appropriate query methods.
.PP
.TP
\fBhand-destroy\fR
This event is generated in response to the removal of a hand from tracking.
.sp
The detail dictionary of this event contains:
.RS
.TP
\fIhand\fR
The id of the lost hand.
.TP
\fItime\fR
A timestamp.
.RE
.sp
\fINote\fR that events are not told the actual state of the
instance. If this information is required then it is the receiver's
responsibility to query the state using the appropriate query methods.
.PP
.SH "AUDIO GENERATOR"
This sections documents the class \fB::kinetcl audio\fR, the concrete
class for all OpenNI audio generator nodes.
.PP
This class inherits from \fB::kinetcl generator\fR and its
superclasses. See section \fBGenerator\fR.
.PP
An audio generator provides access to the stream of sound data
from the sensor.
.SS "CLASS API"
.TP
\fB::kinetcl audio\fR \fBnew\fR
.TP
\fB::kinetcl audio\fR \fBcreate\fR \fIobjname\fR
This command creates a new audio generator instance and returns the
fully qualified name of the instance command. The API provided by that
command, i.e. the set of available methods and their semantics is
described in the next subsection.
.PP
.SS "INSTANCE API"
.TP
\fIaudioInstanceCmd\fR \fBdestroy\fR
This method destroys the audio generator instance and releases all
associated resources, including the instance command. Note that
resources used by multiple instances are released only when the last
instance using them is destroyed.
.sp
The result of the method is the empty string.
.PP
.SH "RECORDER NODE"
This sections documents the class \fB::kinetcl recorder\fR, the
concrete class for all OpenNI recorder nodes.
.PP
This class inherits from \fB::kinetcl base\fR. See section
\fBBase\fR.
.PP
A recorder watches the stream of sensor information in the
system and serializes it to a file. A player node may in the future
read this information and replay it.
.SS "CLASS API"
.TP
\fB::kinetcl recorder\fR \fBnew\fR
.TP
\fB::kinetcl recorder\fR \fBcreate\fR \fIobjname\fR
This command creates a new recorder instance and returns the fully
qualified name of the instance command. The API provided by that
command, i.e. the set of available methods and their semantics is
described in the next subsection.
.PP
.SS "INSTANCE API"
.TP
\fIrecorderInstanceCmd\fR \fBdestroy\fR
This method destroys the recorder instance and releases all associated
resources, including the instance command. Note that resources used
by multiple instances are released only when the last instance using
them is destroyed.
.sp
The result of the method is the empty string.
.PP
.SH "PLAYER NODE"
This sections documents the class \fB::kinetcl player\fR, the
concrete class for all OpenNI player nodes.
.PP
This class inherits from \fB::kinetcl base\fR. See section
\fBBase\fR.
.PP
A player read a stream of sensor information from a file and
injects it into the system, faking the existence of a sensor.
.SS "CLASS API"
.TP
\fB::kinetcl player\fR \fBnew\fR
.TP
\fB::kinetcl player\fR \fBcreate\fR \fIobjname\fR
This command creates a new player instance and returns the fully
qualified name of the instance command. The API provided by that
command, i.e. the set of available methods and their semantics is
described in the next subsection.
.PP
.SS "INSTANCE API"
.TP
\fIplayerInstanceCmd\fR \fBdestroy\fR
This method destroys the player instance and releases all associated
resources, including the instance command. Note that resources used
by multiple instances are released only when the last instance using
them is destroyed.
.sp
The result of the method is the empty string.
.TP
\fIplayerInstanceCmd\fR \fBspeed\fR \fIspeed\fR
This method sets the speed of playback as a ratio of the time passed
in the recording. I.e. a speed of \fB1\fR implies playback at the
same frame/rate as recorded, whereas a speed < 1 causes slow-motion,
and a speed > 1 fast-forward.
.sp
The result of the method is the empty string.
.TP
\fIplayerInstanceCmd\fR \fBspeed\fR
This method returns the speed of playback, as a ratio of the time
passed in the recording.
.sp
The result of the method is a floating point number.
.TP
\fIplayerInstanceCmd\fR \fBrepeat\fR \fIbool\fR
This method activates or deactivates repeating mode. If repeating is
activated (\fIbool\fR is \fBtrue\fR) the player will automatically
rewind to the beginning of the recording when reaching the end, and
continue playing.
.sp
The result of the method is the empty string.
.TP
\fIplayerInstanceCmd\fR \fBeof\fR
This method tests if the player has reached the end of the recording,
or not. Note that this is never \fBtrue\fR when the player is in
repeating mode, however "eof" events are still triggered.
.sp
The result of the method is boolean value, \fBtrue\fR if the
player is at the end of the recording, and \fBfalse\fR else.
.TP
\fIplayerInstanceCmd\fR \fBformat\fR
This method returns the name of the format supported by the player instance.
.TP
\fIplayerInstanceCmd\fR \fBnext\fR
This method causes the player to explicitly advance to the next frame.
.sp
The result of the method is the empty string.
.PP
.SS EVENTS
This class supports the events below. These names can be used as the
\fIevent\fR argument of method \fBbind\fR defined by our super-class
\fB::kinetcl::base\fR.
.TP
\fBeof\fR
This event is generated in response to the player reaching the end of the recording (even when it loops).
.sp
The detail dictionary of this event is empty.
.sp
\fINote\fR that events are not told the actual state of the
instance. If this information is required then it is the receiver's
responsibility to query the state using the appropriate query methods.
.PP
.SH "SCRIPT NODE"
This sections documents the class \fB::kinetcl script\fR, the
concrete class for all OpenNI recorder nodes.
.PP
This class inherits from \fB::kinetcl base\fR. See section
\fBBase\fR.
.PP
A script node can run scripts (sic!), and manages the life-time
of all nodes created by such.
.SS "CLASS API"
.TP
\fB::kinetcl script\fR \fBnew\fR
.TP
\fB::kinetcl script\fR \fBcreate\fR \fIobjname\fR
This command creates a new script instance and returns the fully
qualified name of the instance command. The API provided by that
command, i.e. the set of available methods and their semantics is
described in the next subsection.
.PP
.SS "INSTANCE API"
.TP
\fIscriptInstanceCmd\fR \fBdestroy\fR
This method destroys the script instance and releases all associated
resources, including the instance command. Note that resources used
by multiple instances are released only when the last instance using
them is destroyed.
.sp
The result of the method is the empty string.
.PP
.SH CAPABILITIES
This sections documents the various capabilities a production node may have.
The main classes will all refer to the sub-sections found here.
.SS "ALTERNATIVE VIEWPOINT"
Should an instance support alternate viewpoints the following methods
become available.
This support can checked by invoking the inherited method
\fBis-capable-of\fR for the capability name
\fBalternative-viewpoint\fR.
.TP
\fIinstanceCmd\fR \fBsupports-view\fR \fInode\fR
This method tests if the instance is able to use the viewpoint of the
the other production \fInode\fR. This argument is the object command
of another kinetcl instance.
.sp
The result is a boolean value, \fBtrue\fR if the viewpoint of
\fInode\fR is supported, and \fBfalse\fR else.
.TP
\fIinstanceCmd\fR \fBset-view\fR \fInode\fR
This method sets the instance's viewpoint to the view of the other
production \fInode\fR. This argument is the object command of another
kinetcl instance.
.sp
The result of the method is an empty string. An error is
thrown if the \fInode\fR's viewpoint is not supported.
.TP
\fIinstanceCmd\fR \fBreset-view\fR
This method sets the instance's viewpoint back to its own viewpoint.
.sp
The result of the method is an empty string.
.TP
\fIinstanceCmd\fR \fBusing-view\fR \fInode\fR
This method tests if the instance is currently using the viewpoint of
the other production \fInode\fR. This argument is the object command
of another kinetcl instance.
.sp
The result is a boolean value, \fBtrue\fR if the viewpoint of
\fInode\fR is in use, and \fBfalse\fR else.
.PP
.PP
This capability supports the events below. These names can be
used as the \fIevent\fR argument of method \fBbind\fR defined by
base class \fB::kinetcl::base\fR.
.TP
\fBviewpoint\fR
This event is generated in response to viewpoint changes, i.e. when the instance takes or drops the viewpoint of another node.
.sp
The detail dictionary of this event is empty.
.sp
\fINote\fR that events are not told the actual state of the
instance. If this information is required then it is the receiver's
responsibility to query the state using the appropriate query methods.
.PP
.SS ANTI-FLICKER
Should an instance support anti-flicker behaviour the following
methods become available.
This support can checked by invoking the inherited method
\fBis-capable-of\fR for the capability name \fBantiflicker\fR.
.TP
\fIinstanceCmd\fR \fBfrequency\fR
In this form the method returns the current anti-flicker settings.
.sp
The result is either the string \fBoff\fR, or the powerline
frequency the node is synchronized to.
.TP
\fIinstanceCmd\fR \fBcrop\fR \fIfrequency\fR
In this form the method changes the anit-flicker settings.
The allowed values for \fIfrequency\fR are \fB50\fR, \fB60\fR, and
\fBoff\fR. The latter disables the anti-flicker system.
.sp
The result is an empty string.
.PP
.PP
This capability supports the events below. These names can be
used as the \fIevent\fR argument of method \fBbind\fR defined by
base class \fB::kinetcl::base\fR.
.TP
\fBfrequency\fR
This event is generated in response to reconfiguration of the instance's powerline frequency setting.
.sp
The detail dictionary of this event is empty.
.sp
\fINote\fR that events are not told the actual state of the
instance. If this information is required then it is the receiver's
responsibility to query the state using the appropriate query methods.
.PP
.SS CROPPING
Should an instance support cropping the following methods become
available.
This support can checked by invoking the inherited method
\fBis-capable-of\fR for the capability name \fBcropping\fR.
.TP
\fIinstanceCmd\fR \fBcrop\fR
In this form the method returns the current crop settings.
.sp
The result is a list of 4-elements containing the x- and
y-offset of the crop rectangle, and its horizontal and vertical
dimensions, in this order.
.TP
\fIinstanceCmd\fR \fBcrop\fR \fIx\fR \fIy\fR \fIw\fR \fIh\fR
In this form the method sets the crop rectangle to the specified x-
and y-offset of the crop rectangle, and its horizontal and vertical
dimensions
.sp
The result is an empty string.
.TP
\fIinstanceCmd\fR \fBuncrop\fR
This method deactivates any croppping set on the instance.
.sp
The result of the method is an empty string.
.PP
.PP
This capability supports the events below. These names can be
used as the \fIevent\fR argument of method \fBbind\fR defined by
base class \fB::kinetcl::base\fR.
.TP
\fBcropping\fR
This event is generated in response to reconfiguration of the instance's crop region.
.sp
The detail dictionary of this event is empty.
.sp
\fINote\fR that events are not told the actual state of the
instance. If this information is required then it is the receiver's
responsibility to query the state using the appropriate query methods.
.PP
.SS "FRAME SYNCHRONIZATION"
Should an instance support frame synchronization the following methods
become available.
This support can checked by invoking the inherited method
\fBis-capable-of\fR for the capability name \fBframesync\fR.
.TP
\fIinstanceCmd\fR \fBcan-sync-with\fR \fInode\fR
This method tests if the instance is able to synchronize its
generation of frames with the the other production \fInode\fR. This
argument is the object command of another kinetcl instance.
.sp
The result is a boolean value, \fBtrue\fR if the viewpoint of
\fInode\fR is supported, and \fBfalse\fR else.
.TP
\fIinstanceCmd\fR \fBstart-sync-with\fR \fInode\fR
This method causes the instance's to synchronize its frame generation
with the other production \fInode\fR. This argument is the object
command of another kinetcl instance.
.sp
The result of the method is an empty string. An error is thrown
if the instance is not able to synchronize with \fInode\fR.
.TP
\fIinstanceCmd\fR \fBstop-sync-with\fR \fInode\fR
This method causes the instance's to decouple its frame generation
from the other production \fInode\fR. This argument is the object
command of another kinetcl instance.
.sp
The result of the method is an empty string.
.TP
\fIinstanceCmd\fR \fBsynced-with\fR \fInode\fR
This method tests if the instance is currently synchronized to the
other production \fInode\fR. This argument is the object command of
another kinetcl instance.
.sp
The result is a boolean value, \fBtrue\fR if the instance is
synchronized to \fInode\fR, and \fBfalse\fR else.
.PP
.PP
This capability supports the events below. These names can be
used as the \fIevent\fR argument of method \fBbind\fR defined by
base class \fB::kinetcl::base\fR.
.TP
\fBframesync\fR
This event is generated in response to frame synchronization changes, i.e. when the instance starts or stops synchronization with another node.
.sp
The detail dictionary of this event is empty.
.sp
\fINote\fR that events are not told the actual state of the
instance. If this information is required then it is the receiver's
responsibility to query the state using the appropriate query methods.
.PP
.SS "HAND TOUCHING FOV EDGE"
Should an instance support the events for hands touching the edge of
the field of view the following methods become available.
This support can checked by invoking the inherited method
\fBis-capable-of\fR for the capability name
\fBhand-touching-fov-edge\fR.
.PP
This capability supports the events below. These names can be
used as the \fIevent\fR argument of method \fBbind\fR defined by
base class \fB::kinetcl::base\fR.
.TP
\fBfov-edge\fR
This event is generated in response to hands coming into contact with the edge of the field of view (a box).
.sp
The detail dictionary of this event contains:
.RS
.TP
\fIhand\fR
The numerical id of the hand the event was generated for.
.TP
\fIposition\fR
The position of the hand when it touched the edge. This is a 3-element
list of floating point values containing the \fIreal world\fR
x-, y-, and z-coordinates of the position, in this order.
.TP
\fItimes\fR
The timestamp is a floating point value in seconds.
.TP
\fIdirection\fR
The direction is one of
.RS
.IP [1]
\fBillegal\fR
.IP [2]
\fBleft\fR
.IP [3]
\fBright\fR
.IP [4]
\fBup\fR
.IP [5]
\fBdown\fR
.IP [6]
\fBforward\fR
.IP [7]
\fBbackward\fR
.RE
.RE
.sp
\fINote\fR that events are not told the actual state of the
instance. If this information is required then it is the receiver's
responsibility to query the state using the appropriate query methods.
.PP
.SS MIRROR
Should an instance support mirroring the following methods become
available.
This support can checked by invoking the inherited method
\fBis-capable-of\fR for the capability name \fBmirror\fR.
.TP
\fIinstanceCmd\fR \fBmirror\fR
In this form the method returns the current state of the instance's
mirror flag.
.sp
The result is a boolean value, \fBtrue\fR if the instance
generates mirrored frames, and \fBfalse\fR else.
.TP
\fIinstanceCmd\fR \fBmirror\fR \fIbool\fR
In this form the method (un)sets the instance's mirror flag.
.sp
The result is an empty string.
.PP
.PP
This capability supports the events below. These names can be
used as the \fIevent\fR argument of method \fBbind\fR defined by
base class \fB::kinetcl::base\fR.
.TP
\fBmirror\fR
This event is generated in response to reconfiguration of the instance's mirror flag.
.sp
The detail dictionary of this event is empty.
.sp
\fINote\fR that events are not told the actual state of the
instance. If this information is required then it is the receiver's
responsibility to query the state using the appropriate query methods.
.PP
.SS "POSE DETECTION"
Should an instance support pose detection the following methods become
available.
This support can checked by invoking the inherited method
\fBis-capable-of\fR for the capability name
\fBuser-pose-detection\fR.
.TP
\fIinstanceCmd\fR \fBposes\fR
This method returns a list containing the names of the supported user
poses.
.TP
\fIinstanceCmd\fR \fBis-supported\fR \fIpose\fR
This method tests if the named user pose is supported by the instance.
.sp
The result is a boolean value, \fBtrue\fR if the pose is
supported, and \fBfalse\fR else.
.TP
\fIinstanceCmd\fR \fBstart-detection\fR \fIuser\fR \fIpose\fR
This method activates the detection of the named \fIpose\fR for the
specified \fIuser\fR.
.sp
The result of the method is an empty string.
.TP
\fIinstanceCmd\fR \fBstop-detection\fR \fIuser\fR \fIpose\fR
This method deactivates the detection of the named \fIpose\fR for the
specified \fIuser\fR.
.sp
The result of the method is an empty string.
.TP
\fIinstanceCmd\fR \fBstop-all-detection\fR \fIuser\fR
This method deactivates the detection of any poses for the specified
\fIuser\fR.
.sp
The result of the method is an empty string.
.TP
\fIinstanceCmd\fR \fBstatus\fR \fIuser\fR \fIpose\fR
This method queries the status of the detection of the named \fIpose\fR
for the specified \fIuser\fR.
.sp
The result of the method is 3-element string containing, in the named order
.RS
.IP [1]
The state of the user with respect to the pose,
one of \fBin\fR, \fBout\fR, or \fBundefined\fR
.IP [2]
The status of the detection progress.
.sp
The possible stati are
.RS
.IP [1]
\fBok\fR
.IP [2]
\fBno-user\fR
.IP [3]
\fBtop-fov\fR
.IP [4]
\fBside-fov\fR
.IP [5]
\fBerror\fR
.IP [6]
\fBno-tracking\fR
.RE
.IP [3]
A timestamp telling us when the user entered the pose, if it is
in the pose. If the user is out of the pose \fB0\fR is returned
here.
.RE
.PP
.PP
This capability supports the events below. These names can be
used as the \fIevent\fR argument of method \fBbind\fR defined by
base class \fB::kinetcl::base\fR.
.TP
\fBpose-enter\fR
This event is generated in response to a user entering a pose.
.sp
The detail dictionary of this event contains:
.RS
.TP
\fIpose\fR
The name of the pose the event was generated for.
.TP
\fIuser\fR
The numerical id of the user the event was generated for.
.RE
.sp
\fINote\fR that events are not told the actual state of the
instance. If this information is required then it is the receiver's
responsibility to query the state using the appropriate query methods.
.PP
.TP
\fBpose-exit\fR
This event is generated in response to a user exiting a pose.
.sp
The detail dictionary of this event contains:
.RS
.TP
\fIpose\fR
The name of the pose the event was generated for.
.TP
\fIuser\fR
The numerical id of the user the event was generated for.
.RE
.sp
\fINote\fR that events are not told the actual state of the
instance. If this information is required then it is the receiver's
responsibility to query the state using the appropriate query methods.
.PP
.TP
\fBpose-progress\fR
This event is generated in response to the system's progress in the detection of a pose for a user.
.sp
The detail dictionary of this event contains:
.RS
.TP
\fIpose\fR
The name of the pose the event was generated for.
.TP
\fIuser\fR
The numerical id of the user the event was generated for.
.TP
\fIstatus\fR
The status of the pose detection engine.
.sp
The possible stati are
.RS
.IP [1]
\fBok\fR
.IP [2]
\fBno-user\fR
.IP [3]
\fBtop-fov\fR
.IP [4]
\fBside-fov\fR
.IP [5]
\fBerror\fR
.IP [6]
\fBno-tracking\fR
.RE
.RE
.sp
\fINote\fR that events are not told the actual state of the
instance. If this information is required then it is the receiver's
responsibility to query the state using the appropriate query methods.
.PP
.SS "SKELETON/JOINT TRACKING"
Should an instance support skeleton and joint tracking the following
methods become available.
This support can checked by invoking the inherited method
\fBis-capable-of\fR for the capability name
\fBuser-skeleton\fR.
.TP
\fIinstanceCmd\fR \fBneed-pose\fR
This method tests if the skeleton tracking requires the user to enter
a pose for calibration.
.sp
The result is a boolean value, \fBtrue\fR if entering a pose
is required, and \fBfalse\fR else.
\fINOTE\fR: XXX. The C API to query the name of the required pose
looks to be borken, or underspecified. Research required.
.TP
\fIinstanceCmd\fR \fBis-profile-available\fR \fIprofile\fR
This method tests if the skeleton tracking supports the named
\fIprofile\fR.
.sp
The result is a boolean value, \fBtrue\fR if the profile is
supported, and \fBfalse\fR else.
.sp
The accepted profile names are
.RS
.IP [1]
\fBnone\fR
.IP [2]
\fBall\fR
.IP [3]
\fBupper\fR
.IP [4]
\fBlower\fR
.IP [5]
\fBheads-hands\fR
.RE
.TP
\fIinstanceCmd\fR \fBset-profile\fR \fIprofile\fR
This method activates the named \fIprofile\fR. This will result in
joints getting activated or deactivated, as per the profile.
.sp
The accepted profile names are described above, at
\fBis-profile-available\fR.
.sp
The result of the method is an empty string.
.TP
\fIinstanceCmd\fR \fBset-smoothing\fR \fIfactor\fR
This method sets the skeleton smoothing \fIfactor\fR, a floating point
value.
.sp
The result of the method is an empty string.
.TP
\fIinstanceCmd\fR \fBstart-tracking\fR \fIid\fR
This method activates the tracking of the skeleton for the user
specified by the \fIid\fR.
.sp
The result of the method is an empty string.
.TP
\fIinstanceCmd\fR \fBstop-tracking\fR \fIid\fR
This method stops tracking of the skeleton for the user
specified by the \fIid\fR.
.sp
The result of the method is an empty string.
.TP
\fIinstanceCmd\fR \fBreset-tracking\fR \fIid\fR
This method discards the calibration of the skeleton for the user
specified by the \fIid\fR.
.sp
The result of the method is an empty string.
.TP
\fIinstanceCmd\fR \fBis-tracking\fR \fIid\fR
This method tests if the skeleton for the user \fIid\fR is currently
tracked.
.sp
The result is a boolean value, \fBtrue\fR if tracking is
active, and \fBfalse\fR else.
.TP
\fIinstanceCmd\fR \fBis-calibrated\fR \fIid\fR
This method tests if the skeleton for the user \fIid\fR is calibrated.
.sp
The result is a boolean value, \fBtrue\fR if the skeleton is
calbrated, and \fBfalse\fR else.
.TP
\fIinstanceCmd\fR \fBis-calibrating\fR \fIid\fR
This method tests if calibration of the skeleton for the user \fIid\fR
is currently in progress.
.sp
The result is a boolean value, \fBtrue\fR if calibration is
in progress, and \fBfalse\fR else.
.TP
\fIinstanceCmd\fR \fBrequest-calibration\fR \fIid\fR \fIforce\fR
This method requests calibration of the skeleton for the user
specified by the \fIid\fR.
.sp
The result of the method is an empty string.
.sp
If the boolean flag \fIforce\fR is set any previous calibration
data is discarded.
.TP
\fIinstanceCmd\fR \fBabort-calibration\fR \fIid\fR
This method stops a calibration in progress, for the user specified by
the \fIid\fR.
.sp
The result of the method is an empty string.
.TP
\fIinstanceCmd\fR \fBsave-calibration-file\fR \fIid\fR \fIpath\fR
This method saves the calibration data for the skeleton of the user
specified by the \fIid\fR into the file \fIpath\fR. The format of the
calibration data is not documented.
.sp
The result of the method is an empty string.
.TP
\fIinstanceCmd\fR \fBload-calibration-file\fR \fIid\fR \fIpath\fR
This method loads the calibration data for the skeleton of the user
specified by the \fIid\fR from the file \fIpath\fR. The format of the
calibration data is not documented.
.sp
The result of the method is an empty string.
.TP
\fIinstanceCmd\fR \fBsave-calibration\fR \fIid\fR \fIslot\fR
This method saves the calibration data for the skeleton of the user
specified by the \fIid\fR into the in-memory storage identified by the
\fIslot\fR number.
.sp
The result of the method is an empty string.
.TP
\fIinstanceCmd\fR \fBload-calibration-slot\fR \fIid\fR \fIslot\fR
This method loads the calibration data for the skeleton of the user
specified by the \fIid\fR from the in-memory storage identified by the
\fIslot\fR number.
.sp
The result of the method is an empty string.
.TP
\fIinstanceCmd\fR \fBclear-calibration-slot\fR \fIslot\fR
This method clears the in-memory calibration data storage identified
by the \fIslot\fR number.
.sp
The result of the method is an empty string.
.TP
\fIinstanceCmd\fR \fBis-calibration-slot\fR \fIslot\fR
This method tests if the in-memory storage identified by the
\fIslot\fR number contains skeleton calibration data.
.sp
The result is a boolean value, \fBtrue\fR if the slot is
occupied, and \fBfalse\fR else.
.TP
\fIinstanceCmd\fR \fBis-joint-available\fR \fIjoint\fR
This method tests if the skeleton tracking supports the named
\fIjoint\fR.
.sp
The result is a boolean value, \fBtrue\fR if the joint is
supported, and \fBfalse\fR else.
.sp
The accepted joint names are
.RS
.IP [1]
\fBhead\fR
.IP [2]
\fBneck\fR
.IP [3]
\fBtorso\fR
.IP [4]
\fBwaist\fR
.IP [5]
\fBleft-collar\fR
.IP [6]
\fBleft-shoulder\fR
.IP [7]
\fBleft-elbow\fR
.IP [8]
\fBleft-wrist\fR
.IP [9]
\fBleft-hand\fR
.IP [10]
\fBleft-fingertip\fR
.IP [11]
\fBright-collar\fR
.IP [12]
\fBright-shoulder\fR
.IP [13]
\fBright-elbow\fR
.IP [14]
\fBright-wrist\fR
.IP [15]
\fBright-hand\fR
.IP [16]
\fBright-fingertip\fR
.IP [17]
\fBleft-hip\fR
.IP [18]
\fBleft-knee\fR
.IP [19]
\fBleft-ankle\fR
.IP [20]
\fBleft-foot\fR
.IP [21]
\fBright-hip\fR
.IP [22]
\fBright-knee\fR
.IP [23]
\fBright-ankle\fR
.IP [24]
\fBright-foot\fR
.RE
.TP
\fIinstanceCmd\fR \fBis-joint-active\fR \fIjoint\fR
This method tests if the the named \fIjoint\fR is actively tracked.
.sp
The result is a boolean value, \fBtrue\fR if the joint is
active, and \fBfalse\fR else.
.sp
The accepted joint names are described above, at
\fBis-joint-available\fR.
.TP
\fIinstanceCmd\fR \fBset-joint-active\fR \fIjoint\fR \fIactive\fR
This method (de)activates the named \fIjoint\fR.
.sp
The accepted joint names are described above, at
\fBis-joint-available\fR.
.sp
The result of the method is an empty string.
.TP
\fIinstanceCmd\fR \fBactive-joints\fR
This method returns a list containig the names of all currently active
joints.
.sp
The possible joint names are described above, at
\fBis-joint-available\fR.
.TP
\fIinstanceCmd\fR \fBget-joint\fR \fIuser\fR \fIjoint\fR
This method retrieves position and orientation data for the user
specified by \fIid\fR and the named \fIjoint\fR.
.sp
The accepted joint names are described above, at
\fBis-joint-available\fR.
.sp
The result of the command is a 2-element list containing, in
the order specified:
.RS
.TP
position
A 2-element list containing, in the order specified:
.RS
.TP
confidence
A floating point value representing the system's
confidence in the position information.
.TP
coordinates
A 3-element list of floating point values
representing the x-, y-, and z-position of the joint.
.RE
.TP
orientation
A 2-element list containing, in the order specified:
.RS
.TP
confidence
A floating point value representing the system's
confidence in the orientation information.
.TP
rotation
A 9-element list of floating point values
representating the rotation matrix for the joint.
.RE
.RE
.TP
\fIinstanceCmd\fR \fBget-skeleton\fR \fIuser\fR
This method retrieves the position and orientation data for all joints
of the user specified by \fIid\fR. In other words, the whole skeleton,
as available and active.
.sp
The result of the method is a dictionary mapping joint names to
position and orientation, given in the format returned by method
\fBget-joint\fR.
.sp
Joints which are either not available or not actively tracked
will not be found in the dictionary.
.PP
.PP
This capability supports the events below. These names can be
used as the \fIevent\fR argument of method \fBbind\fR defined by
base class \fB::kinetcl::base\fR.
.TP
\fBjoint\fR
This event is generated in response to joint changes, i.e. the (de)activation of specific joints.
.sp
The detail dictionary of this event is empty.
.sp
\fINote\fR that events are not told the actual state of the
instance. If this information is required then it is the receiver's
responsibility to query the state using the appropriate query methods.
.PP
.TP
\fBcalibration-start\fR
This event is generated in response to the start of skeleton calibration for a user.
.sp
The detail dictionary of this event contains:
.RS
.TP
\fIuser\fR
The numerical id of the user the event was generated for.
.RE
.sp
\fINote\fR that events are not told the actual state of the
instance. If this information is required then it is the receiver's
responsibility to query the state using the appropriate query methods.
.PP
.TP
\fBcalibration-complete\fR
This event is generated in response to the completion of skeleton calibration for a user.
.sp
The detail dictionary of this event contains:
.RS
.TP
\fIuser\fR
The numerical id of the user the event was generated for.
.TP
\fIstatus\fR
The status of the calibration engine.
.sp
The possible stati are
.RS
.IP [1]
\fBok\fR
.IP [2]
\fBno-user\fR
.IP [3]
\fBarm\fR
.IP [4]
\fBleg\fR
.IP [5]
\fBhead\fR
.IP [6]
\fBtorso\fR
.IP [7]
\fBtop-fov\fR
.IP [8]
\fBside-fov\fR
.IP [9]
\fBpose\fR
.IP [10]
\fBmanual-abort\fR
.IP [11]
\fBmanual-reset\fR
.IP [12]
\fBtimeout\fR
.RE
.RE
.sp
\fINote\fR that events are not told the actual state of the
instance. If this information is required then it is the receiver's
responsibility to query the state using the appropriate query methods.
.PP
.TP
\fBcalibration-progress\fR
This event is generated in response to the system's progress in the calibration of the skeleton for a user.
.sp
The detail dictionary of this event contains:
.RS
.TP
\fIuser\fR
The numerical id of the user the event was generated for.
.TP
\fIstatus\fR
The status of the calibration engine.
.sp
The possible stati are
.RS
.IP [1]
\fBok\fR
.IP [2]
\fBno-user\fR
.IP [3]
\fBarm\fR
.IP [4]
\fBleg\fR
.IP [5]
\fBhead\fR
.IP [6]
\fBtorso\fR
.IP [7]
\fBtop-fov\fR
.IP [8]
\fBside-fov\fR
.IP [9]
\fBpose\fR
.IP [10]
\fBmanual-abort\fR
.IP [11]
\fBmanual-reset\fR
.IP [12]
\fBtimeout\fR
.RE
.RE
.sp
\fINote\fR that events are not told the actual state of the
instance. If this information is required then it is the receiver's
responsibility to query the state using the appropriate query methods.
.PP
.SS "BACKLIGHT COMPENSATION"
Should an instance support the backlight-compensation setting the following
methods become available.
This support can checked by invoking the inherited method
\fBis-capable-of\fR for the capability name \fBbacklight-compensation\fR.
.TP
\fIinstanceCmd\fR \fBbacklight-compensation\fR
In this form the method returns the current state of the instance's
backlight-compensation setting.
.sp
The result is an integer.
.TP
\fIinstanceCmd\fR \fBbacklight-compensation\fR \fIvalue\fR
In this form the method changes the instance's backlight-compensation setting
to the specified \fIvalue\fR.
.sp
The result is an empty string.
.TP
\fIinstanceCmd\fR \fBbacklight-compensation-range\fR
This method returns a dictionary describing the allowed domain of
values for the capability. The keys and associated values are:
.RS
.TP
\fBmin\fR
The value is an integer number, the minimal value the setting is
allowed to have.
.TP
\fBmax\fR
The value is an integer number, the maximal value the setting is
allowed to have.
.TP
\fBdefault\fR
The value is an integer number, the default value the setting will
have after node construction.
.TP
\fBstep\fR
The value is an integer number, the difference between two legal
values of the setting.
The difference between \fBmin\fR and \fBmax\fR is a multiple of
this value.
.TP
\fBauto\fR
A boolean value. If \fBtrue\fR the setting supports automatic
adjustment during operation of the node, otherwise not.
.RE
.PP
.PP
This capability supports the events below. These names can be
used as the \fIevent\fR argument of method \fBbind\fR defined by
base class \fB::kinetcl::base\fR.
.TP
\fBbacklight-compensation\fR
This event is generated in response to backlight-compensation changes, i.e. reconfiguration of the instance's backlight-compensation setting.
.sp
The detail dictionary of this event is empty.
.sp
\fINote\fR that events are not told the actual state of the
instance. If this information is required then it is the receiver's
responsibility to query the state using the appropriate query methods.
.PP
.SS BRIGHTNESS
Should an instance support the brightness setting the following
methods become available.
This support can checked by invoking the inherited method
\fBis-capable-of\fR for the capability name \fBbrightness\fR.
.TP
\fIinstanceCmd\fR \fBbrightness\fR
In this form the method returns the current state of the instance's
brightness setting.
.sp
The result is an integer.
.TP
\fIinstanceCmd\fR \fBbrightness\fR \fIvalue\fR
In this form the method changes the instance's brightness setting
to the specified \fIvalue\fR.
.sp
The result is an empty string.
.TP
\fIinstanceCmd\fR \fBbrightness-range\fR
This method returns a dictionary describing the allowed domain of
values for the capability. The keys and associated values are:
.RS
.TP
\fBmin\fR
The value is an integer number, the minimal value the setting is
allowed to have.
.TP
\fBmax\fR
The value is an integer number, the maximal value the setting is
allowed to have.
.TP
\fBdefault\fR
The value is an integer number, the default value the setting will
have after node construction.
.TP
\fBstep\fR
The value is an integer number, the difference between two legal
values of the setting.
The difference between \fBmin\fR and \fBmax\fR is a multiple of
this value.
.TP
\fBauto\fR
A boolean value. If \fBtrue\fR the setting supports automatic
adjustment during operation of the node, otherwise not.
.RE
.PP
.PP
This capability supports the events below. These names can be
used as the \fIevent\fR argument of method \fBbind\fR defined by
base class \fB::kinetcl::base\fR.
.TP
\fBbrightness\fR
This event is generated in response to brightness changes, i.e. reconfiguration of the instance's brightness setting.
.sp
The detail dictionary of this event is empty.
.sp
\fINote\fR that events are not told the actual state of the
instance. If this information is required then it is the receiver's
responsibility to query the state using the appropriate query methods.
.PP
.SS "COLOR TEMPERATURE"
Should an instance support the color-temperature setting the following
methods become available.
This support can checked by invoking the inherited method
\fBis-capable-of\fR for the capability name \fBcolor-temperature\fR.
.TP
\fIinstanceCmd\fR \fBcolor-temperature\fR
In this form the method returns the current state of the instance's
color-temperature setting.
.sp
The result is an integer.
.TP
\fIinstanceCmd\fR \fBcolor-temperature\fR \fIvalue\fR
In this form the method changes the instance's color-temperature setting
to the specified \fIvalue\fR.
.sp
The result is an empty string.
.TP
\fIinstanceCmd\fR \fBcolor-temperature-range\fR
This method returns a dictionary describing the allowed domain of
values for the capability. The keys and associated values are:
.RS
.TP
\fBmin\fR
The value is an integer number, the minimal value the setting is
allowed to have.
.TP
\fBmax\fR
The value is an integer number, the maximal value the setting is
allowed to have.
.TP
\fBdefault\fR
The value is an integer number, the default value the setting will
have after node construction.
.TP
\fBstep\fR
The value is an integer number, the difference between two legal
values of the setting.
The difference between \fBmin\fR and \fBmax\fR is a multiple of
this value.
.TP
\fBauto\fR
A boolean value. If \fBtrue\fR the setting supports automatic
adjustment during operation of the node, otherwise not.
.RE
.PP
.PP
This capability supports the events below. These names can be
used as the \fIevent\fR argument of method \fBbind\fR defined by
base class \fB::kinetcl::base\fR.
.TP
\fBcolor-temperature\fR
This event is generated in response to color-temperature changes, i.e. reconfiguration of the instance's color-temperature setting.
.sp
The detail dictionary of this event is empty.
.sp
\fINote\fR that events are not told the actual state of the
instance. If this information is required then it is the receiver's
responsibility to query the state using the appropriate query methods.
.PP
.SS CONTRAST
Should an instance support the contrast setting the following
methods become available.
This support can checked by invoking the inherited method
\fBis-capable-of\fR for the capability name \fBcontrast\fR.
.TP
\fIinstanceCmd\fR \fBcontrast\fR
In this form the method returns the current state of the instance's
contrast setting.
.sp
The result is an integer.
.TP
\fIinstanceCmd\fR \fBcontrast\fR \fIvalue\fR
In this form the method changes the instance's contrast setting
to the specified \fIvalue\fR.
.sp
The result is an empty string.
.TP
\fIinstanceCmd\fR \fBcontrast-range\fR
This method returns a dictionary describing the allowed domain of
values for the capability. The keys and associated values are:
.RS
.TP
\fBmin\fR
The value is an integer number, the minimal value the setting is
allowed to have.
.TP
\fBmax\fR
The value is an integer number, the maximal value the setting is
allowed to have.
.TP
\fBdefault\fR
The value is an integer number, the default value the setting will
have after node construction.
.TP
\fBstep\fR
The value is an integer number, the difference between two legal
values of the setting.
The difference between \fBmin\fR and \fBmax\fR is a multiple of
this value.
.TP
\fBauto\fR
A boolean value. If \fBtrue\fR the setting supports automatic
adjustment during operation of the node, otherwise not.
.RE
.PP
.PP
This capability supports the events below. These names can be
used as the \fIevent\fR argument of method \fBbind\fR defined by
base class \fB::kinetcl::base\fR.
.TP
\fBcontrast\fR
This event is generated in response to contrast changes, i.e. reconfiguration of the instance's contrast setting.
.sp
The detail dictionary of this event is empty.
.sp
\fINote\fR that events are not told the actual state of the
instance. If this information is required then it is the receiver's
responsibility to query the state using the appropriate query methods.
.PP
.SS EXPOSURE
Should an instance support the exposure setting the following
methods become available.
This support can checked by invoking the inherited method
\fBis-capable-of\fR for the capability name \fBexposure\fR.
.TP
\fIinstanceCmd\fR \fBexposure\fR
In this form the method returns the current state of the instance's
exposure setting.
.sp
The result is an integer.
.TP
\fIinstanceCmd\fR \fBexposure\fR \fIvalue\fR
In this form the method changes the instance's exposure setting
to the specified \fIvalue\fR.
.sp
The result is an empty string.
.TP
\fIinstanceCmd\fR \fBexposure-range\fR
This method returns a dictionary describing the allowed domain of
values for the capability. The keys and associated values are:
.RS
.TP
\fBmin\fR
The value is an integer number, the minimal value the setting is
allowed to have.
.TP
\fBmax\fR
The value is an integer number, the maximal value the setting is
allowed to have.
.TP
\fBdefault\fR
The value is an integer number, the default value the setting will
have after node construction.
.TP
\fBstep\fR
The value is an integer number, the difference between two legal
values of the setting.
The difference between \fBmin\fR and \fBmax\fR is a multiple of
this value.
.TP
\fBauto\fR
A boolean value. If \fBtrue\fR the setting supports automatic
adjustment during operation of the node, otherwise not.
.RE
.PP
.PP
This capability supports the events below. These names can be
used as the \fIevent\fR argument of method \fBbind\fR defined by
base class \fB::kinetcl::base\fR.
.TP
\fBexposure\fR
This event is generated in response to exposure changes, i.e. reconfiguration of the instance's exposure setting.
.sp
The detail dictionary of this event is empty.
.sp
\fINote\fR that events are not told the actual state of the
instance. If this information is required then it is the receiver's
responsibility to query the state using the appropriate query methods.
.PP
.SS FOCUS
Should an instance support the focus setting the following
methods become available.
This support can checked by invoking the inherited method
\fBis-capable-of\fR for the capability name \fBfocus\fR.
.TP
\fIinstanceCmd\fR \fBfocus\fR
In this form the method returns the current state of the instance's
focus setting.
.sp
The result is an integer.
.TP
\fIinstanceCmd\fR \fBfocus\fR \fIvalue\fR
In this form the method changes the instance's focus setting
to the specified \fIvalue\fR.
.sp
The result is an empty string.
.TP
\fIinstanceCmd\fR \fBfocus-range\fR
This method returns a dictionary describing the allowed domain of
values for the capability. The keys and associated values are:
.RS
.TP
\fBmin\fR
The value is an integer number, the minimal value the setting is
allowed to have.
.TP
\fBmax\fR
The value is an integer number, the maximal value the setting is
allowed to have.
.TP
\fBdefault\fR
The value is an integer number, the default value the setting will
have after node construction.
.TP
\fBstep\fR
The value is an integer number, the difference between two legal
values of the setting.
The difference between \fBmin\fR and \fBmax\fR is a multiple of
this value.
.TP
\fBauto\fR
A boolean value. If \fBtrue\fR the setting supports automatic
adjustment during operation of the node, otherwise not.
.RE
.PP
.PP
This capability supports the events below. These names can be
used as the \fIevent\fR argument of method \fBbind\fR defined by
base class \fB::kinetcl::base\fR.
.TP
\fBfocus\fR
This event is generated in response to focus changes, i.e. reconfiguration of the instance's focus setting.
.sp
The detail dictionary of this event is empty.
.sp
\fINote\fR that events are not told the actual state of the
instance. If this information is required then it is the receiver's
responsibility to query the state using the appropriate query methods.
.PP
.SS GAIN
Should an instance support the gain setting the following
methods become available.
This support can checked by invoking the inherited method
\fBis-capable-of\fR for the capability name \fBgain\fR.
.TP
\fIinstanceCmd\fR \fBgain\fR
In this form the method returns the current state of the instance's
gain setting.
.sp
The result is an integer.
.TP
\fIinstanceCmd\fR \fBgain\fR \fIvalue\fR
In this form the method changes the instance's gain setting
to the specified \fIvalue\fR.
.sp
The result is an empty string.
.TP
\fIinstanceCmd\fR \fBgain-range\fR
This method returns a dictionary describing the allowed domain of
values for the capability. The keys and associated values are:
.RS
.TP
\fBmin\fR
The value is an integer number, the minimal value the setting is
allowed to have.
.TP
\fBmax\fR
The value is an integer number, the maximal value the setting is
allowed to have.
.TP
\fBdefault\fR
The value is an integer number, the default value the setting will
have after node construction.
.TP
\fBstep\fR
The value is an integer number, the difference between two legal
values of the setting.
The difference between \fBmin\fR and \fBmax\fR is a multiple of
this value.
.TP
\fBauto\fR
A boolean value. If \fBtrue\fR the setting supports automatic
adjustment during operation of the node, otherwise not.
.RE
.PP
.PP
This capability supports the events below. These names can be
used as the \fIevent\fR argument of method \fBbind\fR defined by
base class \fB::kinetcl::base\fR.
.TP
\fBgain\fR
This event is generated in response to gain changes, i.e. reconfiguration of the instance's gain setting.
.sp
The detail dictionary of this event is empty.
.sp
\fINote\fR that events are not told the actual state of the
instance. If this information is required then it is the receiver's
responsibility to query the state using the appropriate query methods.
.PP
.SS GAMMA
Should an instance support the gamma setting the following
methods become available.
This support can checked by invoking the inherited method
\fBis-capable-of\fR for the capability name \fBgamma\fR.
.TP
\fIinstanceCmd\fR \fBgamma\fR
In this form the method returns the current state of the instance's
gamma setting.
.sp
The result is an integer.
.TP
\fIinstanceCmd\fR \fBgamma\fR \fIvalue\fR
In this form the method changes the instance's gamma setting
to the specified \fIvalue\fR.
.sp
The result is an empty string.
.TP
\fIinstanceCmd\fR \fBgamma-range\fR
This method returns a dictionary describing the allowed domain of
values for the capability. The keys and associated values are:
.RS
.TP
\fBmin\fR
The value is an integer number, the minimal value the setting is
allowed to have.
.TP
\fBmax\fR
The value is an integer number, the maximal value the setting is
allowed to have.
.TP
\fBdefault\fR
The value is an integer number, the default value the setting will
have after node construction.
.TP
\fBstep\fR
The value is an integer number, the difference between two legal
values of the setting.
The difference between \fBmin\fR and \fBmax\fR is a multiple of
this value.
.TP
\fBauto\fR
A boolean value. If \fBtrue\fR the setting supports automatic
adjustment during operation of the node, otherwise not.
.RE
.PP
.PP
This capability supports the events below. These names can be
used as the \fIevent\fR argument of method \fBbind\fR defined by
base class \fB::kinetcl::base\fR.
.TP
\fBgamma\fR
This event is generated in response to gamma changes, i.e. reconfiguration of the instance's gamma setting.
.sp
The detail dictionary of this event is empty.
.sp
\fINote\fR that events are not told the actual state of the
instance. If this information is required then it is the receiver's
responsibility to query the state using the appropriate query methods.
.PP
.SS HUE
Should an instance support the hue setting the following
methods become available.
This support can checked by invoking the inherited method
\fBis-capable-of\fR for the capability name \fBhue\fR.
.TP
\fIinstanceCmd\fR \fBhue\fR
In this form the method returns the current state of the instance's
hue setting.
.sp
The result is an integer.
.TP
\fIinstanceCmd\fR \fBhue\fR \fIvalue\fR
In this form the method changes the instance's hue setting
to the specified \fIvalue\fR.
.sp
The result is an empty string.
.TP
\fIinstanceCmd\fR \fBhue-range\fR
This method returns a dictionary describing the allowed domain of
values for the capability. The keys and associated values are:
.RS
.TP
\fBmin\fR
The value is an integer number, the minimal value the setting is
allowed to have.
.TP
\fBmax\fR
The value is an integer number, the maximal value the setting is
allowed to have.
.TP
\fBdefault\fR
The value is an integer number, the default value the setting will
have after node construction.
.TP
\fBstep\fR
The value is an integer number, the difference between two legal
values of the setting.
The difference between \fBmin\fR and \fBmax\fR is a multiple of
this value.
.TP
\fBauto\fR
A boolean value. If \fBtrue\fR the setting supports automatic
adjustment during operation of the node, otherwise not.
.RE
.PP
.PP
This capability supports the events below. These names can be
used as the \fIevent\fR argument of method \fBbind\fR defined by
base class \fB::kinetcl::base\fR.
.TP
\fBhue\fR
This event is generated in response to hue changes, i.e. reconfiguration of the instance's hue setting.
.sp
The detail dictionary of this event is empty.
.sp
\fINote\fR that events are not told the actual state of the
instance. If this information is required then it is the receiver's
responsibility to query the state using the appropriate query methods.
.PP
.SS IRIS
Should an instance support the iris setting the following
methods become available.
This support can checked by invoking the inherited method
\fBis-capable-of\fR for the capability name \fBiris\fR.
.TP
\fIinstanceCmd\fR \fBiris\fR
In this form the method returns the current state of the instance's
iris setting.
.sp
The result is an integer.
.TP
\fIinstanceCmd\fR \fBiris\fR \fIvalue\fR
In this form the method changes the instance's iris setting
to the specified \fIvalue\fR.
.sp
The result is an empty string.
.TP
\fIinstanceCmd\fR \fBiris-range\fR
This method returns a dictionary describing the allowed domain of
values for the capability. The keys and associated values are:
.RS
.TP
\fBmin\fR
The value is an integer number, the minimal value the setting is
allowed to have.
.TP
\fBmax\fR
The value is an integer number, the maximal value the setting is
allowed to have.
.TP
\fBdefault\fR
The value is an integer number, the default value the setting will
have after node construction.
.TP
\fBstep\fR
The value is an integer number, the difference between two legal
values of the setting.
The difference between \fBmin\fR and \fBmax\fR is a multiple of
this value.
.TP
\fBauto\fR
A boolean value. If \fBtrue\fR the setting supports automatic
adjustment during operation of the node, otherwise not.
.RE
.PP
.PP
This capability supports the events below. These names can be
used as the \fIevent\fR argument of method \fBbind\fR defined by
base class \fB::kinetcl::base\fR.
.TP
\fBiris\fR
This event is generated in response to iris changes, i.e. reconfiguration of the instance's iris setting.
.sp
The detail dictionary of this event is empty.
.sp
\fINote\fR that events are not told the actual state of the
instance. If this information is required then it is the receiver's
responsibility to query the state using the appropriate query methods.
.PP
.SS "LOWLIGHT COMPENSATION"
Should an instance support the lowlight-compensation setting the following
methods become available.
This support can checked by invoking the inherited method
\fBis-capable-of\fR for the capability name \fBlowlight-compensation\fR.
.TP
\fIinstanceCmd\fR \fBlowlight-compensation\fR
In this form the method returns the current state of the instance's
lowlight-compensation setting.
.sp
The result is an integer.
.TP
\fIinstanceCmd\fR \fBlowlight-compensation\fR \fIvalue\fR
In this form the method changes the instance's lowlight-compensation setting
to the specified \fIvalue\fR.
.sp
The result is an empty string.
.TP
\fIinstanceCmd\fR \fBlowlight-compensation-range\fR
This method returns a dictionary describing the allowed domain of
values for the capability. The keys and associated values are:
.RS
.TP
\fBmin\fR
The value is an integer number, the minimal value the setting is
allowed to have.
.TP
\fBmax\fR
The value is an integer number, the maximal value the setting is
allowed to have.
.TP
\fBdefault\fR
The value is an integer number, the default value the setting will
have after node construction.
.TP
\fBstep\fR
The value is an integer number, the difference between two legal
values of the setting.
The difference between \fBmin\fR and \fBmax\fR is a multiple of
this value.
.TP
\fBauto\fR
A boolean value. If \fBtrue\fR the setting supports automatic
adjustment during operation of the node, otherwise not.
.RE
.PP
.PP
This capability supports the events below. These names can be
used as the \fIevent\fR argument of method \fBbind\fR defined by
base class \fB::kinetcl::base\fR.
.TP
\fBlowlight-compensation\fR
This event is generated in response to lowlight-compensation changes, i.e. reconfiguration of the instance's lowlight-compensation setting.
.sp
The detail dictionary of this event is empty.
.sp
\fINote\fR that events are not told the actual state of the
instance. If this information is required then it is the receiver's
responsibility to query the state using the appropriate query methods.
.PP
.SS PAN
Should an instance support the pan setting the following
methods become available.
This support can checked by invoking the inherited method
\fBis-capable-of\fR for the capability name \fBpan\fR.
.TP
\fIinstanceCmd\fR \fBpan\fR
In this form the method returns the current state of the instance's
pan setting.
.sp
The result is an integer.
.TP
\fIinstanceCmd\fR \fBpan\fR \fIvalue\fR
In this form the method changes the instance's pan setting
to the specified \fIvalue\fR.
.sp
The result is an empty string.
.TP
\fIinstanceCmd\fR \fBpan-range\fR
This method returns a dictionary describing the allowed domain of
values for the capability. The keys and associated values are:
.RS
.TP
\fBmin\fR
The value is an integer number, the minimal value the setting is
allowed to have.
.TP
\fBmax\fR
The value is an integer number, the maximal value the setting is
allowed to have.
.TP
\fBdefault\fR
The value is an integer number, the default value the setting will
have after node construction.
.TP
\fBstep\fR
The value is an integer number, the difference between two legal
values of the setting.
The difference between \fBmin\fR and \fBmax\fR is a multiple of
this value.
.TP
\fBauto\fR
A boolean value. If \fBtrue\fR the setting supports automatic
adjustment during operation of the node, otherwise not.
.RE
.PP
.PP
This capability supports the events below. These names can be
used as the \fIevent\fR argument of method \fBbind\fR defined by
base class \fB::kinetcl::base\fR.
.TP
\fBpan\fR
This event is generated in response to pan changes, i.e. reconfiguration of the instance's pan setting.
.sp
The detail dictionary of this event is empty.
.sp
\fINote\fR that events are not told the actual state of the
instance. If this information is required then it is the receiver's
responsibility to query the state using the appropriate query methods.
.PP
.SS ROLL
Should an instance support the roll setting the following
methods become available.
This support can checked by invoking the inherited method
\fBis-capable-of\fR for the capability name \fBroll\fR.
.TP
\fIinstanceCmd\fR \fBroll\fR
In this form the method returns the current state of the instance's
roll setting.
.sp
The result is an integer.
.TP
\fIinstanceCmd\fR \fBroll\fR \fIvalue\fR
In this form the method changes the instance's roll setting
to the specified \fIvalue\fR.
.sp
The result is an empty string.
.TP
\fIinstanceCmd\fR \fBroll-range\fR
This method returns a dictionary describing the allowed domain of
values for the capability. The keys and associated values are:
.RS
.TP
\fBmin\fR
The value is an integer number, the minimal value the setting is
allowed to have.
.TP
\fBmax\fR
The value is an integer number, the maximal value the setting is
allowed to have.
.TP
\fBdefault\fR
The value is an integer number, the default value the setting will
have after node construction.
.TP
\fBstep\fR
The value is an integer number, the difference between two legal
values of the setting.
The difference between \fBmin\fR and \fBmax\fR is a multiple of
this value.
.TP
\fBauto\fR
A boolean value. If \fBtrue\fR the setting supports automatic
adjustment during operation of the node, otherwise not.
.RE
.PP
.PP
This capability supports the events below. These names can be
used as the \fIevent\fR argument of method \fBbind\fR defined by
base class \fB::kinetcl::base\fR.
.TP
\fBroll\fR
This event is generated in response to roll changes, i.e. reconfiguration of the instance's roll setting.
.sp
The detail dictionary of this event is empty.
.sp
\fINote\fR that events are not told the actual state of the
instance. If this information is required then it is the receiver's
responsibility to query the state using the appropriate query methods.
.PP
.SS SATURATION
Should an instance support the saturation setting the following
methods become available.
This support can checked by invoking the inherited method
\fBis-capable-of\fR for the capability name \fBsaturation\fR.
.TP
\fIinstanceCmd\fR \fBsaturation\fR
In this form the method returns the current state of the instance's
saturation setting.
.sp
The result is an integer.
.TP
\fIinstanceCmd\fR \fBsaturation\fR \fIvalue\fR
In this form the method changes the instance's saturation setting
to the specified \fIvalue\fR.
.sp
The result is an empty string.
.TP
\fIinstanceCmd\fR \fBsaturation-range\fR
This method returns a dictionary describing the allowed domain of
values for the capability. The keys and associated values are:
.RS
.TP
\fBmin\fR
The value is an integer number, the minimal value the setting is
allowed to have.
.TP
\fBmax\fR
The value is an integer number, the maximal value the setting is
allowed to have.
.TP
\fBdefault\fR
The value is an integer number, the default value the setting will
have after node construction.
.TP
\fBstep\fR
The value is an integer number, the difference between two legal
values of the setting.
The difference between \fBmin\fR and \fBmax\fR is a multiple of
this value.
.TP
\fBauto\fR
A boolean value. If \fBtrue\fR the setting supports automatic
adjustment during operation of the node, otherwise not.
.RE
.PP
.PP
This capability supports the events below. These names can be
used as the \fIevent\fR argument of method \fBbind\fR defined by
base class \fB::kinetcl::base\fR.
.TP
\fBsaturation\fR
This event is generated in response to saturation changes, i.e. reconfiguration of the instance's saturation setting.
.sp
The detail dictionary of this event is empty.
.sp
\fINote\fR that events are not told the actual state of the
instance. If this information is required then it is the receiver's
responsibility to query the state using the appropriate query methods.
.PP
.SS SHARPNESS
Should an instance support the sharpness setting the following
methods become available.
This support can checked by invoking the inherited method
\fBis-capable-of\fR for the capability name \fBsharpness\fR.
.TP
\fIinstanceCmd\fR \fBsharpness\fR
In this form the method returns the current state of the instance's
sharpness setting.
.sp
The result is an integer.
.TP
\fIinstanceCmd\fR \fBsharpness\fR \fIvalue\fR
In this form the method changes the instance's sharpness setting
to the specified \fIvalue\fR.
.sp
The result is an empty string.
.TP
\fIinstanceCmd\fR \fBsharpness-range\fR
This method returns a dictionary describing the allowed domain of
values for the capability. The keys and associated values are:
.RS
.TP
\fBmin\fR
The value is an integer number, the minimal value the setting is
allowed to have.
.TP
\fBmax\fR
The value is an integer number, the maximal value the setting is
allowed to have.
.TP
\fBdefault\fR
The value is an integer number, the default value the setting will
have after node construction.
.TP
\fBstep\fR
The value is an integer number, the difference between two legal
values of the setting.
The difference between \fBmin\fR and \fBmax\fR is a multiple of
this value.
.TP
\fBauto\fR
A boolean value. If \fBtrue\fR the setting supports automatic
adjustment during operation of the node, otherwise not.
.RE
.PP
.PP
This capability supports the events below. These names can be
used as the \fIevent\fR argument of method \fBbind\fR defined by
base class \fB::kinetcl::base\fR.
.TP
\fBsharpness\fR
This event is generated in response to sharpness changes, i.e. reconfiguration of the instance's sharpness setting.
.sp
The detail dictionary of this event is empty.
.sp
\fINote\fR that events are not told the actual state of the
instance. If this information is required then it is the receiver's
responsibility to query the state using the appropriate query methods.
.PP
.SS TILT
Should an instance support the tilt setting the following
methods become available.
This support can checked by invoking the inherited method
\fBis-capable-of\fR for the capability name \fBtilt\fR.
.TP
\fIinstanceCmd\fR \fBtilt\fR
In this form the method returns the current state of the instance's
tilt setting.
.sp
The result is an integer.
.TP
\fIinstanceCmd\fR \fBtilt\fR \fIvalue\fR
In this form the method changes the instance's tilt setting
to the specified \fIvalue\fR.
.sp
The result is an empty string.
.TP
\fIinstanceCmd\fR \fBtilt-range\fR
This method returns a dictionary describing the allowed domain of
values for the capability. The keys and associated values are:
.RS
.TP
\fBmin\fR
The value is an integer number, the minimal value the setting is
allowed to have.
.TP
\fBmax\fR
The value is an integer number, the maximal value the setting is
allowed to have.
.TP
\fBdefault\fR
The value is an integer number, the default value the setting will
have after node construction.
.TP
\fBstep\fR
The value is an integer number, the difference between two legal
values of the setting.
The difference between \fBmin\fR and \fBmax\fR is a multiple of
this value.
.TP
\fBauto\fR
A boolean value. If \fBtrue\fR the setting supports automatic
adjustment during operation of the node, otherwise not.
.RE
.PP
.PP
This capability supports the events below. These names can be
used as the \fIevent\fR argument of method \fBbind\fR defined by
base class \fB::kinetcl::base\fR.
.TP
\fBtilt\fR
This event is generated in response to tilt changes, i.e. reconfiguration of the instance's tilt setting.
.sp
The detail dictionary of this event is empty.
.sp
\fINote\fR that events are not told the actual state of the
instance. If this information is required then it is the receiver's
responsibility to query the state using the appropriate query methods.
.PP
.SS ZOOM
Should an instance support the zoom setting the following
methods become available.
This support can checked by invoking the inherited method
\fBis-capable-of\fR for the capability name \fBzoom\fR.
.TP
\fIinstanceCmd\fR \fBzoom\fR
In this form the method returns the current state of the instance's
zoom setting.
.sp
The result is an integer.
.TP
\fIinstanceCmd\fR \fBzoom\fR \fIvalue\fR
In this form the method changes the instance's zoom setting
to the specified \fIvalue\fR.
.sp
The result is an empty string.
.TP
\fIinstanceCmd\fR \fBzoom-range\fR
This method returns a dictionary describing the allowed domain of
values for the capability. The keys and associated values are:
.RS
.TP
\fBmin\fR
The value is an integer number, the minimal value the setting is
allowed to have.
.TP
\fBmax\fR
The value is an integer number, the maximal value the setting is
allowed to have.
.TP
\fBdefault\fR
The value is an integer number, the default value the setting will
have after node construction.
.TP
\fBstep\fR
The value is an integer number, the difference between two legal
values of the setting.
The difference between \fBmin\fR and \fBmax\fR is a multiple of
this value.
.TP
\fBauto\fR
A boolean value. If \fBtrue\fR the setting supports automatic
adjustment during operation of the node, otherwise not.
.RE
.PP
.PP
This capability supports the events below. These names can be
used as the \fIevent\fR argument of method \fBbind\fR defined by
base class \fB::kinetcl::base\fR.
.TP
\fBzoom\fR
This event is generated in response to zoom changes, i.e. reconfiguration of the instance's zoom setting.
.sp
The detail dictionary of this event is empty.
.sp
\fINote\fR that events are not told the actual state of the
instance. If this information is required then it is the receiver's
responsibility to query the state using the appropriate query methods.
.PP
.SH "EVENT BASE"
This sections documents the class \fB::kinetcl ventbase\fR, a base
class supplying general event management facilities.
.PP
This class has no superclasses, i.e it inherit nothing.
.PP
It itself is used by the classes
\fB::kinetcl nodeevents\fR (described in section
\fBNode Events\fR) and \fB::kinetcl joints\fR (described in
section \fBJoint Events\fR.
.SS "CLASS API"
.TP
\fB::kinetcl eventbase\fR \fBnew\fR
.TP
\fB::kinetcl eventbase\fR \fBcreate\fR \fIobjname\fR
This command creates a new instance of the class, either automatically
named (\fBnew\fR), or explicitly (\fBcreate\fR).
The API provided by the instance, i.e. the set of available methods
and their semantics is described in the next subsection.
.PP
.SS "INSTANCE API"
.TP
\fIinstanceCmd\fR \fBbind\fR \fIevent\fR \fIcmdprefix\fR
This method binds the command prefix \fIcmdprefix\fR to the specified
\fIevent\fR and returns an opaque token for the binding.
.sp
The system ensures that everybody with an interest in the event
(i.e. having to know if there are bindings or not) is notified and can
take action.
.sp
The result of the method is an opaque token.
.sp
The command prefix is expected to have the following signature:
.RS
.TP
\fB{*}$cmdprefix\fR \fIevent\fR \fIinstance\fR \fIdetails\fR
.RS
\fIevent\fR
The name of the event which triggered the command. First argument,
thus allowing it to be used as a sub-command or method of an ensemble
or object instance.
\fIinstance\fR
The object instance generating the event.
\fIdetails\fR
Event specific data with more information about the event.
.RE
.RE
.TP
\fIinstanceCmd\fR \fBunbind\fR \fItoken\fR
This method removes the event binding represented by the opaque \fItoken\fR,
a result of a call to method \fBbind\fR above.
.sp
The system ensures that everybody with an interest in the event
(i.e. having to know if there are bindings or not) is notified and can
take action.
.sp
The result of the method is an empty string.
.TP
\fIinstanceCmd\fR \fBgenerate\fR \fIevent\fR \fIdetails\fR
This method generates the named event, ensuring that all bindings are
called and supplied with the given \fIdetails\fR. The structure of
said details depends on the event in question.
.TP
\fIinstanceCmd\fR \fBbound\fR
This is an abstract method which can be overridden by derived classes.
As is it does nothing.
.sp
It is invoked when the instance becomes known as having
bindings for any event.
.sp
The result of the method is ignored.
.TP
\fIinstanceCmd\fR \fBunbound\fR
This is an abstract method which can be overridden by derived classes.
As is it does nothing.
.sp
It is invoked when the instance becomes known as having no
bindings anymore, for no events.
.sp
The result of the method is ignored.
.TP
\fIinstanceCmd\fR \fBevent-bound\fR \fIevent\fR
This is an abstract method which can be overridden by derived classes.
As is it does nothing.
.sp
It is invoked when the named event becomes known as having
bindings.
.sp
The result of the method is ignored.
.TP
\fIinstanceCmd\fR \fBevent-unbound\fR \fIevent\fR
This is an abstract method which can be overridden by derived classes.
As is it does nothing.
.sp
It is invoked when the named event becomes known as having no
bindings anymore.
.sp
The result of the method is ignored.
.TP
\fIinstanceCmd\fR \fBRegister\fR \fIevents\fR
This is a method for use by derived classes. It takes a list of event
names and arranges for notification when bindings to the instance and
these events come into existence or are removed.
.sp
This information is used to drive the invokations of the
abstract methods above, i.e. \fBbound\fR, \fBunbound\fR,
\fBevent-bound\fR, and \fBevent-unbound\fR.
.sp
The result of the method is an empty string.
.PP
.SH "NODE EVENTS"
This sections documents the class \fB::kinetcl nodeevents\fR, a base
class supplying the event management for all OpenNI production nodes
dervided from class \fB::kinetcl base\fR described in section
\fBBase\fR.
.PP
This class inherits from \fB::kinetcl eventbase\fR for the
overall management of events. See section \fBEvent Base\fR.
.SS "CLASS API"
.TP
\fB::kinetcl nodeevents\fR \fBnew\fR
.TP
\fB::kinetcl nodeevents\fR \fBcreate\fR \fIobjname\fR
This command creates a new instance of the class, either automatically
named (\fBnew\fR), or explicitly (\fBcreate\fR).
The API provided by the instance, i.e. the set of available methods
and their semantics is described in the next subsection.
.PP
.SS "INSTANCE API"
.TP
\fIinstanceCmd\fR \fBSetupEventsOf\fR \fInode\fR
This method introspects the C-level OpenNI instance \fInode\fR and
registers all callbacks it exposes (via a method pair
\fBset-callback-*\fR, \fBunset-callback-*\fR) as events the instance
is able to generate.
.sp
It further remembers the mapping from event names to the
\fInode\fR instances generating them.
.sp
The result of the method is an empty string.
.PP
.SH "JOINT EVENTS"
This sections documents the class \fB::kinetcl joints\fR, a class
providing proper event based tracking of user skeletons.
.PP
This class inherits from \fB::kinetcl eventbase\fR for the
overall management of the events it generates.
See section \fBEvent Base\fR.
.PP
Instances of the class rely on a (possibly external) instance
of class \fB::kinetcl user\fR
(See section \fBUser Generator\fR) and its events for the basic
aquisition and tracking of users.
.SS "CLASS API"
.TP
\fB::kinetcl joints\fR \fBnew\fR ?\fIuser\fR?
.TP
\fB::kinetcl joints\fR \fBcreate\fR \fIobjname\fR ?\fIuser\fR?
This command creates a new instance of the class, either automatically
named (\fBnew\fR), or explicitly (\fBcreate\fR).
The API provided by the instance, i.e. the set of available methods
and their semantics is described in the next subsection.
.sp
If the argument \fIuser\fR is specified then it must be an
instance of class \fB::kinetcl user\fR.
See section \fBUser Generator\fR for details. In the future we
\fImay\fR relax these restriction to require only API cmopatibility.
.sp
If no such instance is specified the new instance will itself
create such an instance.
.sp
This user generator is used to get the basic events for
tracking users and skeletons the instance will then transform into
more suitable form and events.
.sp
Note that any instance methods invoked and not known to the
class (see below for the known API) are delegated to the user
generator for handling, making the instance look like an extended user
generator.
.PP
.SS "INSTANCE API"
.TP
\fIinstanceCmd\fR \fBthreshold\fR
In this form the method returns the value of the confidence threshold
used to distinguish between good and ignorable joint locations. The
default is \fB0.5\fR.
.TP
\fIinstanceCmd\fR \fBthreshold\fR \fIvalue\fR
In this form the method configures the instance to use the new
\fIvalue\fR of the confidence threshold used to distinguish between
good and ignorable joint locations. This value must be a floating
point number in the range \fB0\fR..\fB1\fR.
.TP
\fIinstanceCmd\fR \fBget-generator\fR
The method returns the instance command of the user generator
provinding the raw information about users and skeletons. This is
either the generator specified at instance construction time, or the
internally created generator.
.TP
\fIinstanceCmd\fR \fBget-joint\fR \fIuser\fR \fIjoint\fR
This method returns the location of the named \fIjoint\fR for the
specified \fIuser\fR (id).
.sp
This information comes out of an internal cache maintained by
the instance, to avoid having to go to the underlying user generator.
.sp
The result of the method is a 3D location in world coordinates.
.TP
\fIinstanceCmd\fR \fBget-skeleton\fR \fIuser\fR
This method returns the location of all joints currently known for the
specified \fIuser\fR (id).
.sp
This information comes out of an internal cache maintained by
the instance, to avoid having to go to the underlying user generator.
.sp
The result of the method is a dictionary mapping joint names to
3D locations in world coordinates.
.PP
.SS EVENTS
This class supports the events below. These names can be used as the
\fIevent\fR argument of method \fBbind\fR defined by our super-class
\fB::kinetcl::base\fR.
.TP
\fBuser-create\fR
This event is generated in response to the appearance of new users in the scene.
.sp
The detail dictionary of this event contains:
.RS
.TP
\fIuser\fR
The numerical id of the user the event was generated for.
.RE
.sp
\fINote\fR that events are not told the actual state of the
instance. If this information is required then it is the receiver's
responsibility to query the state using the appropriate query methods.
.PP
.TP
\fBuser-move\fR
This event is generated in response to the user moving in the scene.
.sp
The detail dictionary of this event contains:
.RS
.TP
\fIuser\fR
The numerical id of the user the event was generated for.
.RE
.sp
\fINote\fR that events are not told the actual state of the
instance. If this information is required then it is the receiver's
responsibility to query the state using the appropriate query methods.
.PP
.TP
\fBuser-destroy\fR
This event is generated in response to the disappearance of users from the scene.
.sp
The detail dictionary of this event contains:
.RS
.TP
\fIuser\fR
The numerical id of the user the event was generated for.
.RE
.sp
\fINote\fR that events are not told the actual state of the
instance. If this information is required then it is the receiver's
responsibility to query the state using the appropriate query methods.
.PP
.TP
\fBjoint-create\fR
This event is generated in response to the appearance of a user's joint (confident position).
.sp
The detail dictionary of this event contains:
.RS
.TP
\fIuser\fR
The numerical id of the user the event was generated for.
.TP
\fIjoint\fR
The name of the joint the event was generated for.
.TP
\fIposition\fR
The current position of the joint. This is a 3-element list of
floating point values containing the \fIreal world\fR x-, y-, and
z-coordinates of the position, in this order.
.RE
.sp
\fINote\fR that events are not told the actual state of the
instance. If this information is required then it is the receiver's
responsibility to query the state using the appropriate query methods.
.PP
.TP
\fBjoint-move\fR
This event is generated in response to the user's joint's movement in the scene.
.sp
The detail dictionary of this event contains:
.RS
.TP
\fIuser\fR
The numerical id of the user the event was generated for.
.TP
\fIjoint\fR
The name of the joint the event was generated for.
.TP
\fIposition\fR
The current position of the joint. This is a 3-element list of
floating point values containing the \fIreal world\fR x-, y-, and
z-coordinates of the position, in this order.
.RE
.sp
\fINote\fR that events are not told the actual state of the
instance. If this information is required then it is the receiver's
responsibility to query the state using the appropriate query methods.
.PP
.TP
\fBjoint-destroy\fR
This event is generated in response to the disappearance of a user's joint (non-confident position).
.sp
The detail dictionary of this event contains:
.RS
.TP
\fIuser\fR
The numerical id of the user the event was generated for.
.TP
\fIjoint\fR
The name of the joint the event was generated for.
.RE
.sp
\fINote\fR that events are not told the actual state of the
instance. If this information is required then it is the receiver's
responsibility to query the state using the appropriate query methods.
.PP
.SH "STANCE EVENTS"
This sections documents the class \fB::kinetcl stance\fR, a class
for the recognition of \fIstances\fR, also known as \fIposes\fR or
\fIbody gestures\fR. Events are generated whenever a user enters or
leaves a stance.
.PP
This was in general inspired by the concept of
\fIFAAST body gestures\fR [http://projects.ict.usc.edu/mxr/faast/]
mentioned at \fIhttp://fivedots.coe.psu.ac.th/~ad/jg/nui1610/index.html\fR.
.PP
This class inherits from \fB::kinetcl eventbase\fR for the
overall management of the events it generates.
See section \fBEvent Base\fR.
.PP
Instances of the class rely on an external instance of class
\fB::kinetcl joints\fR (See section \fBJoint Events\fR) and
its events for the tracking of users and their skeleton joints.
.PP
Multiple instances can trivially share the same joint tracker
instance, given that the communication from tracker to recognizer is
by events and bindings.
.SS "CLASS API"
.TP
\fB::kinetcl stance\fR \fBnew\fR \fIjoints\fR
.TP
\fB::kinetcl stance\fR \fBcreate\fR \fIobjname\fR \fIjoints\fR
This command creates a new instance of the class, either automatically
named (\fBnew\fR), or explicitly (\fBcreate\fR).
The API provided by the instance, i.e. the set of available methods
and their semantics is described in the next subsection.
.sp
The \fIjoints\fR argument must be a joint tracking object which
is API compatible to instances of class \fB::kinetcl joints\fR.
.sp
This tracker is monitored for the creation, movement and
destruction of users, in response to which the referenced user and its
joints are run through the stance recognizer.
.PP
.SS "INSTANCE API"
.TP
\fIinstanceCmd\fR \fBadd\fR \fIname\fR \fIscript\fR
This method defines a new stance to be recognized by the instance,
identified by \fIname\fR. The \fIscript\fR is the recognizer for the
stance and is invoked whenever a user moved, as this may have caused
her to either enter or exit the stance.
.sp
The context and commands available to this script are explained
in detail in section \fBStance Recognition Language\fR.
.sp
The script has to return a boolean value, \fBtrue\fR if the
stance is recognized, and \fBfalse\fR otherwise.
.sp
Events are send whenever this information changes (per-user).
.sp
Note that a user can be in multiple stances at the same time.
.sp
The result of the method is the empty string.
.TP
\fIinstanceCmd\fR \fBremove\fR \fIname\fR
This method removes the \fIname\fRd stance from the instance, stopping
its future recognition.
.sp
The result of the method is the empty string.
.TP
\fIinstanceCmd\fR \fBmeasure\fR \fIname\fR \fIscript\fR
This method extends the gesture recognition language used by the
instance with a \fIname\fRd measure(ment), a cacheable piece of
information about a user's skeleton.
.sp
The value of the measure is computed once, per user, by
invoking the \fIscript\fR. The result of the script is the value of
the measurement.
.sp
The context and commands available to this script are explained
in detail in section \fBStance Recognition Language\fR.
.sp
The set of predefined measures is explained in section
\fBPredefined Measurements\fR.
.sp
The result of the method is the empty string.
.PP
.SS EVENTS
This class supports the events below. These names can be used as the
\fIevent\fR argument of method \fBbind\fR defined by our super-class
\fB::kinetcl::base\fR.
.TP
\fBstance-enter\fR
This event is generated in response to a user entering a recognized stance.
.sp
The detail dictionary of this event contains:
.RS
.TP
\fIuser\fR
The numerical id of the user the event was generated for.
.TP
\fIstance\fR
The name of the stance the event is for.
.RE
.sp
\fINote\fR that events are not told the actual state of the
instance. If this information is required then it is the receiver's
responsibility to query the state using the appropriate query methods.
.PP
.TP
\fBstance-exit\fR
This event is generated in response to a user leaving a recognized stance.
.sp
The detail dictionary of this event contains:
.RS
.TP
\fIuser\fR
The numerical id of the user the event was generated for.
.TP
\fIstance\fR
The name of the stance the event is for.
.RE
.sp
\fINote\fR that events are not told the actual state of the
instance. If this information is required then it is the receiver's
responsibility to query the state using the appropriate query methods.
.PP
.SS "STANCE RECOGNITION LANGUAGE"
All stance recognition and measurement scripts are executed within a
namespace which provides the commands below:
.TP
Math
All of Tcl's builtin math functions and operators.
.TP
Measurements
All named measurements of the instance running the script, as commands
taking no arguments and returning the value of the measurement.
.TP
Skeleton
.RS
.TP
\fBhead\fR
.TP
\fBneck\fR
.TP
\fBtorso\fR
.TP
\fBwaist\fR
.TP
\fBleft-collar\fR
.TP
\fBleft-shoulder\fR
.TP
\fBleft-elbow\fR
.TP
\fBleft-wrist\fR
.TP
\fBleft-hand\fR
.TP
\fBleft-fingertip\fR
.TP
\fBleft-hip\fR
.TP
\fBleft-knee\fR
.TP
\fBleft-ankle\fR
.TP
\fBleft-foot\fR
.TP
\fBright-collar\fR
.TP
\fBright-shoulder\fR
.TP
\fBright-elbow\fR
.TP
\fBright-wrist\fR
.TP
\fBright-hand\fR
.TP
\fBright-fingertip\fR
.TP
\fBright-hip\fR
.TP
\fBright-knee\fR
.TP
\fBright-ankle\fR
.TP
\fBright-foot\fR
These commands return the location of the named joint in world
coordinates, for the user the script is invoked for.
If the joint is not defined for that user, the script is aborted, and
the gesture's enter/exit state is not changed.
.RE
.TP
Distances
.RS
.TP
\fBdistance\fR \fIjointa\fR \fIjointb\fR
.TP
\fBdistance_side\fR \fIjointa\fR \fIjointb\fR
.TP
\fBdistance_height\fR \fIjointa\fR \fIjointb\fR
.TP
\fBdistance_depth\fR \fIjointa\fR \fIjointb\fR
In this form the commands take the names of two joints, determine
their locations and then compute the euclidean distance between them,
or the distance along the named axes.
.sp
For the names of the possible joints see the command names
above.
.sp
The result of the commands is a floating point value, the
computed distance.
.TP
\fBdistance\fR \fIsegment\fR
.TP
\fBdistance_side\fR \fIsegment\fR
.TP
\fBdistance_height\fR \fIsegment\fR
.TP
\fBdistance_depth\fR \fIsegment\fR
In this form the commands take the names of a single segment and
compute it length, either the full euclidean distance between its
joints, or the length along the named axes.
.sp
The following segments are known:
.RS
.TP
left-lower-arm
left-hand   -- left-elbow
.TP
left-upper-arm
left-elbow  -- left-shoulder
.TP
left-lower-leg
left-foot   -- left-knee
.TP
left-upper-leg
left-knee   -- left-hip
.TP
right-lower-arm
right-hand  -- right-elbow
.TP
right-upper-arm
right-elbow -- right-shoulder
.TP
right-lower-leg
right-foot  -- right-knee
.TP
right-upper-leg
right-knee  -- right-hip
.RE
.RE
.TP
Undirected Axis Alignment
.RS
.TP
\fBhorizontal_side\fR \fIjointa\fR \fIjointb\fR
.TP
\fBvertical\fR \fIjointa\fR \fIjointb\fR
.TP
\fBhorizontal_depth\fR \fIjointa\fR \fIjointb\fR
.TP
\fBhorizontal_side\fR \fIsegment\fR
.TP
\fBvertical\fR \fIsegment\fR
.TP
\fBhorizontal_depth\fR \fIsegment\fR
The commands take the names of two joints or of one segment (which
maps to two joints), determine their locations and then check if these
locations are aligned with the primary axes of the coordinate system.
.sp
The result of the commands is a boolean value, \fBtrue\fR if
the relationship holds, and \fBfalse\fR otherwise.
.RE
.TP
Directed Axis Alignment
.RS
.TP
\fBhorizontal_right\fR \fIjointa\fR \fIjointb\fR
.TP
\fBhorizontal_left\fR \fIjointa\fR \fIjointb\fR
.TP
\fBvertical_up\fR \fIjointa\fR \fIjointb\fR
.TP
\fBvertical_down\fR \fIjointa\fR \fIjointb\fR
.TP
\fBhorizontal_backward\fR \fIjointa\fR \fIjointb\fR
.TP
\fBhorizontal_forward\fR \fIjointa\fR \fIjointb\fR
.TP
\fBhorizontal_right\fR \fIsegment\fR
.TP
\fBhorizontal_left\fR \fIsegment\fR
.TP
\fBvertical_up\fR \fIsegment\fR
.TP
\fBvertical_down\fR \fIsegment\fR
.TP
\fBhorizontal_backward\fR \fIsegment\fR
.TP
\fBhorizontal_forward\fR \fIsegment\fR
The commands take the names of two joints or of one segment (which
maps to two joints), determine their locations and then check if these
locations are aligned with the primary axes of the coordinate system,
and in the described relationship.
.sp
The result of the commands is a boolean value, \fBtrue\fR if
the relationship holds, and \fBfalse\fR otherwise.
.RE
.TP
General Spatial Relationships
.RS
.TP
\fBright\fR \fIjointa\fR \fIjointb\fR
.TP
\fBleft\fR \fIjointa\fR \fIjointb\fR
.TP
\fBabove\fR \fIjointa\fR \fIjointb\fR
.TP
\fBbelow\fR \fIjointa\fR \fIjointb\fR
.TP
\fBbefore\fR \fIjointa\fR \fIjointb\fR
.TP
\fBbehind\fR \fIjointa\fR \fIjointb\fR
.TP
\fBright\fR \fIsegment\fR
.TP
\fBleft\fR \fIsegment\fR
.TP
\fBabove\fR \fIsegment\fR
.TP
\fBbelow\fR \fIsegment\fR
.TP
\fBbefore\fR \fIsegment\fR
.TP
\fBbehind\fR \fIsegment\fR
The commands take the names of two joints or of one segment (which
maps to two joints), determine their locations and then check if these
locations are in the described relationship.
.sp
The result of the commands is a boolean value, \fBtrue\fR if
the relationship holds, and \fBfalse\fR otherwise.
.RE
.TP
Unit Conversion
.RS
.TP
\fBmm\fR \fIx\fR
.TP
\fBcm\fR \fIx\fR
.TP
\fBinch\fR \fIx\fR
These command convert floating point values from various units to
millimeters. The result of the commands are the conversion results.
.RE
.PP
.SS "PREDEFINED MEASUREMENTS"
All instances of \fB::kinetcl stance\fR know the following
measurements:
.TP
left-neck-length
The distance from left soulder to neck.
.TP
left-upper-arm-length
The distance from left shoulder to left elbow.
.TP
left-lower-arm-length
The distance from left hand to left elbow.
.TP
right-neck-length
The distance from right soulder to neck.
.TP
right-upper-arm-length
The distance from right shoulder to right elbox.
.TP
right-lower-arm-length
The distance from right hand to right elbow.
.TP
neck-length
The minimum of both neck lengths above.
.TP
upper-arm-length
The minimum of both upper arm lengths above.
.TP
lower-arm-length
The minimum of both lower arm lengths above.
.PP
.SS EXAMPLES
.SH "BUGS, IDEAS, FEEDBACK"
This document, and the package it describes, will undoubtedly contain
bugs and other problems.
Please report such at the \fIKineTcl Tracker\fR [http://chiselapp.com/user/andreas_kupries/repository/KineTcl].
Please also report any ideas for enhancements you may have for either
package and/or documentation.
.SH KEYWORDS
3D vision, Kinect, OpenNI, PrimeSense, computer vision, tracking, volume sensor
.SH CATEGORY
3rd party library binding
.SH COPYRIGHT
.nf
Copyright (c) 2012 Andreas Kupries
Copyright (c) 2012 Documentation, Andreas Kupries

.fi